//package NetML;
import java.io.*;
import java.util.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class Router {

  private String type; //J,C,Z,(V?)
  private String filexml ; // The path of the xml file
  private String filexsl ; // The path of the xml file
  private String xsltContent; // The content of a xslt file
  private String RID; // The router id
  private String result; // the result of the transformation

  //Patterns to match in order to modify the xslt
  private static String selectRouterIdDelimit = "<!-- ###RouterID### -->";
  private static String ProtocolIncludeStart = "<!-- ###ProtocolIncludeStart###";
  private static String ProtocolIncludeEnd = "###ProtocolIncludeEnd### -->";
  private static String PolicyListStart = "<!-- ###Policy-List-Start###" ;
  private static String PolicyListEnd = "###Policy-List-End### -->" ;


  //private static String prefixXsl = "/home/ivan79/cvsgiga/project/xslt/";
  private static Hashtable pathXsl;

  /**
   * Replace the ruoter-id at the beginning of the xsl file
   * The xslt is the already loaded file!
   */
  public static String replaceRID ( String xslt , String RID){

  return  xslt.replaceFirst(
    selectRouterIdDelimit +".*"+ selectRouterIdDelimit ,
    selectRouterIdDelimit + "<xsl:variable name=\"routerID\">"+
    RID + "</xsl:variable>" + selectRouterIdDelimit);

  }

  /**
   * Load the xsl file, change it, call trans to make the transformation!
   *
   */

  public String start () {

    try {

      //Load the file (must be initialized first!)
      this.xsltContent = utils.loadFile(this.filexsl);
      this.xsltContent = Router.replaceRID(this.xsltContent, this.RID);

      //Change the xslt include directives to match the real location
      //Uses this.prefixXsl
      Vector include = new Vector();
      //Cisco stylesheets
      if (this.type.startsWith("c")) {

	include.add("bgp-cisco.xsl");
	include.add("interface-cisco.xsl");
	include.add("list-cisco.xsl");
	include.add("policy-cisco.xsl");
	include.add("ripconf-cisco.xsl");
	include.add("router-cisco.xsl");

      }
      //Juniper stylesheets (xml)
      if (this.type.startsWith("jxml")) {

	include.add("policy-juniper.xsl");
	include.add("ripconf-juniper.xsl");
	include.add("router-juniper.xsl");
        include.add("bgp-juniper.xsl");
      }
      //Juniper stylesheets (text)
      if (this.type.startsWith("jtxt")) {

	include.add("bgp-juniper-text.xsl");
	include.add("policy-juniper-text.xsl");
	include.add("ripconf-juniper-text.xsl");
	include.add("router-juniper-text.xsl");

      }

      //Zebra stylesheets
      //Could also be z-rip or z-bgp
      if (this.type.startsWith("z")) {

	include.add("bgp-zebra.xsl");
	include.add("list-zebra.xsl");
	include.add("policy-zebra.xsl");
	include.add("ripconf-zebra.xsl");
	include.add("router-zebra.xsl");

      }

      //Old version to change the include path in the xslt files
      //Uses this version because of a bug in xalan!

      /**
       * It changes
       * <xsl:include href="policy-zebra.xsl"/>
       * with something like this:
       * <xsl:include href="/home/user/NetML/xslt/policy-zebra.xsl"/>
       *
       * because the xslt processor must know the absolute path of the
       * file to include (This is how this application functions!)
       */

      for (int i=0; i<include.size() ; i++) {
	String tmp = (String) include.elementAt(i);
	this.xsltContent = this.xsltContent.replaceFirst(
                   tmp, utils.xslPath() + tmp);

      }


      if (this.type.equals("z-rip") || this.type.equals("z-bgp")) {
        // Then we are transforming for a particular
        // protocol. Eg: z-bgp or z-rip
        this.xsltContent = this.xsltContent.replaceFirst(
            this.ProtocolIncludeStart, this.ProtocolIncludeStart +" -->");
        this.xsltContent = this.xsltContent.replaceFirst(
            this.ProtocolIncludeEnd, "<!-- " + this.ProtocolIncludeEnd);

        this.xsltContent = this.xsltContent.replaceFirst(
            this.PolicyListStart, this.PolicyListStart +" -->");
        this.xsltContent = this.xsltContent.replaceFirst(
            this.PolicyListEnd, "<!-- "+ this.PolicyListEnd);

        //Now the delimiters are split in separate comments,
        //making the include statemets visible to the transformer
      }


      //Decomment these if you want to see the modified xsl
      //Viewer v = new Viewer();
      //v.setText(this.xsltContent);

      Trans t = new Trans();
      this.result = t.start(this.filexml, this.xsltContent);
      return this.result;
    }
    catch (Exception e) {
      e.printStackTrace();
      return null;
}



  }

  //Construct the application
  public Router(String fxml , String rId , String t) {

    //Assign each letter type a filename
    //This is done once by the first class created
    if (Router.pathXsl == null) {
      Router.pathXsl = new Hashtable(20);
      // The path for the complete configuration
      Router.pathXsl.put("c", "router-cisco.xsl");
      Router.pathXsl.put("z", "router-zebra.xsl");
      Router.pathXsl.put("jxml", "router-juniper.xsl");
      Router.pathXsl.put("jtxt", "router-juniper-text.xsl");
      // The path for BGP and RIP configuration
      Router.pathXsl.put("z-bgp", "bgp-zebra.xsl");
      Router.pathXsl.put("z-rip", "ripconf-zebra.xsl");
}


    this.filexml= fxml;
    this.RID = rId;
    //Check that the type passed is valid
    //   t = t.toLowerCase(); NOT ALLOWED!!!
    // To do the comparison get the enumeration of the keys and make a
    //comparison with the type t passed:
    Enumeration keys = this.pathXsl.keys();
    boolean found = false;
    while (keys.hasMoreElements() && ! found) {
      String tmp = (String) keys.nextElement();
      found = tmp.equals(t);
    }
    if (found) {
      this.type = t;
      this.filexsl= utils.xslPath() + this.pathXsl.get(t);

    } else {
      System.err.println("Type invalid!");
      System.exit(100);
    }

  }

  //Main method
  public static void main(String[] args) {

    //System.out.println( utils.pwd());
    //System.out.println( utils.xsdPath());
    //System.out.println( utils.xslPath());
    //System.out.println( args[0]);
    //System.exit(12);


    //These are the variables that are to be passed via command line
    String fXml ;
    String outputDir;
    String type;

    if (args.length==1 && (args[0].equals("--help") || args[0].equals("-h"))) {
      Router.usage();
      System.exit(0);
    }

    //arguments check (START)
    HashMap params = utils.parseParams(args);
    if (params == null) { //Something has gone wrong

      System.err.println("Bad arguments!");
      Router.usage();
      System.exit(1001);
    }

    fXml = (String) params.remove("x");

    if (fXml == null ) {
      System.err.println("You must specify a xml file");
      System.exit(1002);
    }

    outputDir = (String) params.remove("d");
    if (outputDir == null ) {
      System.err.println("You must specify an output directory");
      System.exit(1003);
    }

    type = (String) params.remove("t");
    if (type == null ) {
      System.err.println("You must specify an output type");
      System.exit(1004);
    }

    if (! params.isEmpty()) {
      System.err.println("Too many arguments!");
      Router.usage();
      System.exit(1005);

    }


    //arguments check (END)

    //Gets the lists of router id and hostnames
    String [] routers = utils.GetRouterList(fXml);
    String [] names = utils.GetRouterNames(fXml);


    // The next if is needed because we must treat zebra files in a different
    // way.
    // In this first part we are doing all but zebra
    if (! type.startsWith("z")) {

      //for each router apply the transformation
      int errors = 0;  // unused yet
      for (int i = 0; i < routers.length; i++) {

        System.out.println();
        System.out.println("--------------------------");
        System.out.println("RouterID: " + routers[i] + " Hostname: " + names[i]);

        //do the transformation
        Router r = new Router(fXml, routers[i], type);
        String output = r.start();

        //System.out.println(output);

        //write to file
        long n = -1;
        if (output.length() > 0) {
          n = utils.writeFile(outputDir + routers[i] + "-" + names[i] + "." +
                              type, output);
        }
        if (n != -1) {
          System.out.println("-------DONE------");
        }
        else {
          System.out.println("-------ERROR?------");
          errors++;
        }
      }
    } else { // Let'so do zebra now!

      for (int i = 0; i < routers.length; i++) {

        System.out.println();
        System.out.println("--------------------------");
        System.out.println("RouterID: " + routers[i] + " Hostname: " + names[i]);

        //RIP transformation
        Router r_rip = new Router(fXml, routers[i], "z-rip");
        String output_rip = r_rip.start();

        //write to file
        long n_rip = -1;
        if (output_rip.length() > 0) {
          n_rip = utils.writeFile(outputDir + routers[i] + "-" + names[i] + "-" +
                              "ripd.conf", output_rip);
        }
        if (n_rip != -1) {
          System.out.println("-------RIP-DONE------");
        }
        else {
          System.out.println("-------NO-RIP?------");
        }

        //BGP transformation
        Router r_bgp = new Router(fXml, routers[i], "z-bgp");
        String output_bgp = r_bgp.start();

        //write to file
        long n_bgp = -1;
        if (output_bgp.length() > 0) {
          n_bgp = utils.writeFile(outputDir + routers[i] + "-" + names[i] + "-" +
                              "bgpd.conf", output_bgp);
        }
        if (n_bgp != -1) {
          System.out.println("-------BGP-DONE------");
        }
        else {
          System.out.println("-------NO-BGP?------");
        }

        //Creating the zebra daemons file - based on the previous results

        boolean rip_present = output_rip.length() >0;
        boolean bgp_present = output_bgp.length() >0;
        boolean zebra_present = rip_present || bgp_present;

        StringBuffer output_daemons = new StringBuffer();

        boolean zebra_Present = rip_present || bgp_present;
        if (zebra_Present) {

          String r = (rip_present ? "yes" : "no");
          String b = (bgp_present ? "yes" : "no");
          output_daemons.append(
              " # This file tells the zebra package  \n" +
              " # which daemons to start. \n" +
              " zebra=yes \n" +
              " bgpd=" + b + " \n" +
              " ospfd=no \n" +
              " ospf6d=no \n" +
              " ripd=" + r + " \n" +
              " ripngd=no \n"
              );

          long n_daemons = utils.writeFile(
              outputDir + routers[i] + "-" + names[i] + "-" +
              "daemons", output_daemons.toString());

          if (n_bgp != -1) {
            System.out.println("-------DAEMONS-DONE------");
          }
          else {
            System.out.println("-------ERROR?------");
          }



        }










/*
                  cat > /etc/zebra/daemons <<EOF
# This file tells the zebra package
# which daemons to start.
zebra=yes
bgpd=yes
ospfd=no
ospf6d=no
ripd=no
ripngd=no
EOF



*/






      }




    }


  }
  /**
   * Router.usage() prints out all the possible parameters of the application
   */
  static void usage() {
    System.out.println();
    System.out.println("Available arguments:");
    System.out.println();
    System.out.println("-x filexml");
    System.out.println("-t type ( c | z | jtxt | jxml )");
    System.out.println("-d outputDir");
    System.out.println();
    System.out.println(
        "The outputDir is intended to be a subdir of the 'output' directory. "+
        "If it doesn't exist it will be created");
    System.out.println();


  }
}
