//package NetML;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Ivan Santarelli
 * @version 0.1
 */

// Imported TraX classes
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import org.apache.xml.utils.*;

// Imported java classes
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.*;

// Ivan imported SAX classes
//import javax.xml.parsers.SAXParser;
//import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import javax.xml.transform.sax.SAXSource;
import javax.xml.transform.ErrorListener;
import javax.xml.transform.TransformerException;

import javax.xml.transform.*;
import org.xml.sax.helpers.XMLReaderFactory;

public class Trans implements ErrorHandler,ErrorListener,URIResolver {

  // ------------------------------------------

  /** Namespaces feature id (http://xml.org/sax/features/namespaces). */
  protected static final String NAMESPACES_FEATURE_ID = "http://xml.org/sax/features/namespaces";

  /** Validation feature id (http://xml.org/sax/features/validation). */
  protected static final String VALIDATION_FEATURE_ID = "http://xml.org/sax/features/validation";

  /** Schema validation feature id (http://apache.org/xml/features/validation/schema). */
  protected static final String SCHEMA_VALIDATION_FEATURE_ID = "http://apache.org/xml/features/validation/schema";

  /** Schema full checking feature id (http://apache.org/xml/features/validation/schema-full-checking). */
  protected static final String SCHEMA_FULL_CHECKING_FEATURE_ID = "http://apache.org/xml/features/validation/schema-full-checking";

  /** Default parser name. */
  protected static final String DEFAULT_PARSER_NAME = "org.apache.xerces.parsers.SAXParser";

  // ------------------------------------------

  private  String filexml;
  private  String filexsl;
  private int errors = 0;
  private int fatalErrors = 0;
  private int warnings = 0;
  private StringWriter out ; //Contains the output of the transformation
  private StringWriter err; //Contains the error output
  private Transformer transformer;

  private Viewer viewerOut;
  private Viewer viewerErr;

  private XMLReader reader = null; //E' il parser!!!
  private SAXSource source;
  private TransformerFactory tFactory;

  public Trans() throws SAXException, ParserConfigurationException,IOException,
      TransformerException {

    out = new StringWriter();
    err = new StringWriter();

    reader = XMLReaderFactory.createXMLReader(DEFAULT_PARSER_NAME);

    //Default BEHAVIOUR: Validates
    reader.setFeature(SCHEMA_VALIDATION_FEATURE_ID, true);
    reader.setFeature(NAMESPACES_FEATURE_ID, true);
    reader.setFeature(VALIDATION_FEATURE_ID, true);
    reader.setFeature(SCHEMA_FULL_CHECKING_FEATURE_ID, true);
    reader.setErrorHandler(this);

    //Instructs the parser to use the correct xsd file
    reader.setProperty("http://apache.org/xml/properties/schema/external-schemaLocation",
          "http://www.xmlnetwork.org "+ utils.xsdPath());

    /* For debugging
    System.out.println("W - E - FE : " + this.warnings + " "
                           + this.errors + " " + this.fatalErrors);
     */


  }


  public static void main(String[] args)
	  throws SAXException, ParserConfigurationException,IOException,TransformerException {

        Trans t = new Trans();

	//imbroglio:
	if (args.length == 2) {
	  t.setXml(args[0]);
	  t.setXsl( args[1]);
	} else {

          System.out.println("Fornire filexml e filexsl altrimenti uso "+
					   "due file predefiniti e i risultati... mmhhmm!!");
          String [] xm = new String[3];
          String [] xs = new String[3];

          xm[1] = "/home/ivan79/cvsgiga/project/xmlschema/prova_router1.xml";
          xs[1] = "/home/ivan79/cvsgiga/project/xslt/ripconf-cisco.xsl";

          xm[2] = "/home/ivan79/xalan-j_2_4_1/samples/SimpleTransform/birds.xml";
          xs[2] = "/home/ivan79/xalan-j_2_4_1/samples/SimpleTransform/birds.xsl";


          boolean b1 = t.setXml(xm[1]);
          boolean b2 = t.setXsl(xs[1]);
          if (! b1) System.out.println("ERR XML");
          if (! b2) System.out.println("ERR XSL");
	}

        t.start();

  }
  /**
   * Start() Begin the transformation
   *
   */

  public void start(){

    this.source = new SAXSource(reader ,new InputSource(filexml));

    this.tFactory = TransformerFactory.newInstance();

    try {
      transformer = tFactory.newTransformer(new StreamSource(this.filexsl));
    } catch (TransformerConfigurationException e) {
      e.printStackTrace();
    }

    this.transformer.setErrorListener(this);

    try {
      //(1)
      //this.transformer.transform(new StreamSource(filexml), new StreamResult(out));
      //(2)
      this.transformer.transform(source, new StreamResult(out));
    } catch (TransformerException e) {
      e.printStackTrace();
    }

    System.out.println("W - E - FE : " + this.warnings + " "
                                       + this.errors + " " + this.fatalErrors );
    System.out.println( out.toString().length() + "-" + err.toString().length());

/*
    if (out.toString().length() > 0 ) {
      viewerOut = new Viewer();
      viewerOut.setTitle("Output Viewer");
      viewerOut.setText(out.toString());
    }

    if (err.toString().length() > 0 ) {
      viewerErr = new Viewer();
      viewerErr.setTitle("Error Viewer");
      viewerErr.setText(err.toString());
    } */
}

/** Start() begins the trasformation
 * the arguments are two Strings:
 * -filexml (The name of the xml file containing the description of the network)
 * -xslt (The CONTENT of the xslt file that has to be applied to the xml)
 *
 */

 public String start  (String fxml, String xslt) throws TransformerException{

   this.source = new SAXSource(reader, new InputSource(fxml));

   //this.tFactory.setURIResolver(this);
   //this.tFactory.getURIResolver().resolve("href111","base1111");
   //There is a bug in xalan!!!

   this.tFactory = TransformerFactory.newInstance();

   try {
     //transformer.setURIResolver(this);
     transformer = tFactory.newTransformer(new StreamSource(new StringReader(
	 xslt)));

   }
   catch (TransformerConfigurationException e) {
     e.printStackTrace();
   }

   this.transformer.setErrorListener(this);
//   this.transformer.setURIResolver(this);
//---
   try {
     this.transformer.transform(source, new StreamResult(out));
   }
   catch (TransformerException e) {
     e.printStackTrace();
   }

   //System.out.println(out.toString().length() + "-" + err.toString().length());

   System.out.println("Transformation report:");
   System.out.println("WARNINGS: " + this.warnings);
   System.out.println("ERRORS: " + this.errors);
   System.out.println("FATAL ERRORS: " +  this.fatalErrors);

   return out.toString();


  }

  public boolean  setXml (String f) {

    if ( new File(f).exists() ) {
      this.filexml = f;
      return true;
    } else {
      return false;
    }
  }

  public boolean setXsl (String f) {
    if ( new File(f).exists() ) {
      this.filexsl = f;
      return true;
    } else {
      return false;
    }

  }

  public void setNotValidating() throws SAXNotSupportedException,
      SAXNotRecognizedException{

    reader.setFeature(SCHEMA_VALIDATION_FEATURE_ID, false);
    reader.setFeature(SCHEMA_FULL_CHECKING_FEATURE_ID, false);
    reader.setFeature(VALIDATION_FEATURE_ID, false);

  }



// get errors, get outwriter, oppure get outString - errString (meglio!)
  public String getErr() {
	return this.err.toString();
  }

  public String getOut() {
	return this.out.toString();
  }

  public int getWarnings() {
	return this.warnings;
  }

  public int getErrors() {
	return this.errors;
  }

  public int getFatalErrors(){
	return this.fatalErrors;
  }

  //---------------------------------------------------
  // These 3 functions are here because this class implements ErrorHandler
  public void error(SAXParseException e){
	//Receive notification of a recoverable error
	//System.out.println("Error: "+ e.getMessage() + "\n"+ e.getLineNumber() +","
	//				  + e.getColumnNumber() + " in " + e.getSystemId() );
	System.out.println("Error");
	this.getDetailedMessages(e);
	this.errors++;

  }
  public void fatalError(SAXParseException e){
	//Receive notification of a non - recoverable error
	System.out.println("FatalError: " + e.getMessage());
	this.getDetailedMessages(e);
	this.fatalErrors++ ;

  }
  public void warning(SAXParseException e){
	//Receive notification of a warning
	System.out.println("Warning: " + e.getMessage());
	//this.getDetailedMessages(e);
	this.warnings++;

  }


  private void getDetailedMessages(SAXParseException e) {
	System.out.println(e.getMessage() + "\n"+ e.getLineNumber() +","
					  + e.getColumnNumber() + " in " + e.getSystemId() );
  }

  private void getDetailedMessages(TransformerException e) {
  System.out.println( e.getMessageAndLocation());
  System.out.println( e.toString());
  e.printStackTrace();
}


  //---------------------------------------------------
  // These 3 functions are here because this class implements ErrorListener
  public void error(TransformerException e){
	//Receive notification of a recoverable error
	//System.out.println("Error: "+ e.getMessage() + "\n"+ e.getLineNumber() +","
	//				  + e.getColumnNumber() + " in " + e.getSystemId() );
	//System.out.println("Error" + e.getMessage());
	//err.write("Error: " + e.getMessage() + "\n");
	this.getDetailedMessages(e);
	this.errors++;

  }
  public void fatalError(TransformerException e){
	//Receive notification of a non - recoverable error
	//System.out.println("FatalError: " + e.getMessage());
	//err.write("FatalError: " + e.getMessage() + "\n" );
	this.getDetailedMessages(e);
	this.fatalErrors++ ;

  }
  public void warning(TransformerException e){
	//Receive notification of a warning
	System.out.println("Warning: " + e.getMessage());
	//err.write("Warning: " + e.getMessage() + "\n");
	//this.getDetailedMessages(e);
	this.warnings++;

  }
  //BUG: This function is not called!!!
  public Source resolve(String href, String base) {

    System.out.println("href = "+ href);
    System.out.println("base = "+ base);
    Source s = (Source) new InputSource("/home/ivan79/");
    return s;

  }

}
