//package NetML;

import java.io.*;
import java.util.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class utils {


  /**
   * Load a file and reports it into a string
   *
   */
   
   private static String selectMachineIdDelimit = "<!-- ###MachineID### -->";
   
   public static String replaceMID ( String xslt , String MID){

  return  xslt.replaceFirst(
    selectMachineIdDelimit +".*"+ selectMachineIdDelimit ,
    selectMachineIdDelimit + "<xsl:variable name=\"machineID\">"+
    MID + "</xsl:variable>" + selectMachineIdDelimit);

  }

  public static String loadFile(String filename) {

    try {
      BufferedReader f = new BufferedReader(new FileReader(filename));
      long size = new File(filename).length();

      char [] tmp = new char[(int) size] ;
      f.read(tmp);
      return new String(tmp);
    }
    
    catch (Exception e) {
      e.printStackTrace();
    }
    return null;

  }

  /**
   * Write content to a file (filename) and reports the file length
   *
   */
  public static long writeFile(String filename, String content) {

    try {
      File f = new File(filename);
      if (f.canWrite()) {
	System.out.println("Opened "+ filename + " in write mode");
      }
      BufferedWriter w = new BufferedWriter(new FileWriter(f));
      w.write(content);
      w.flush();
      w.close();
      System.out.println("Written "+ f.length() + " bytes.");

      return f.length();

    }
    catch (Exception e) {
      System.out.println("Error: " + e.getMessage());
      return -1;
    }

  }
  /**
   * Returns the path of the utils subdirectory
   */

  public static String utilsPrefix() {
    String sep = System.getProperty("file.separator");
    return utils.pwd() + sep + "xslt" + sep + "utils" + sep;
  }

    /**
     * Returns an array containing the router id's
     */

public static String[] GetRouterList (String xml) {

    String xsl = utils.utilsPrefix() + "routerlist.xsl";
    String rs= SimpleTransform.Start(xml,xsl);
    //Example of rs: rs = "r01 ; r02 ; r03 ; ";
    String [] tmp = rs.split(";");
    String [] routers = new String [tmp.length -1];

    for (int i = 0 ; i< tmp.length -1; i++) {
      routers[i] = tmp[i].trim();
    }
    return routers;
  }

  /**
   * Returns an array containing the hostnames
   */
  public static String[] GetRouterNames (String xml) {

      String xsl = utils.utilsPrefix() + "routerNames.xsl";
      String rs= SimpleTransform.Start(xml,xsl);
      //Example of rs: rs = "Magnum ; Router1 ; roma-rtg ; ";
      String [] tmp = rs.split(";");
      String [] routers = new String [tmp.length -1];

      for (int i = 0 ; i< tmp.length -1; i++) {
	routers[i] = tmp[i].trim();
      }
      return routers;

    }



  /**
   * Returns an array containing the firewall hostnames
   */
  public static String[] GetFirewallNames (String xml) {

      String xsl = utils.utilsPrefix() + "firewallNames.xsl";
      String rs= SimpleTransform.Start(xml,xsl);
      System.out.println(rs);
      //Example of rs: rs = "Magnum ; Router1 ; roma-rtg ; ";
      String [] tmp = rs.split(";");
      String [] firewalls = new String [tmp.length -1];

      for (int i = 0 ; i< tmp.length -1; i++) {
	firewalls[i] = tmp[i].trim();
      }
      return firewalls;

    }
    
    

    /**
     * Returns a string with the collision domains
     */
    public static String GetRouterCollD (String xml, String rId) {

      String xsl = utils.utilsPrefix() + "routerCollDomain.xsl";
      //load the xsl and change the router id
      String xslContent = utils.loadFile(xsl);
      xslContent = Router.replaceRID(xslContent,rId);
      String rs= SimpleTransform.StartXsltContent(xml,xslContent);
      return rs;
    }
    
        /**
     * Returns a string with the firewall configuration
     */
    
    public static String GetRouterFwall (String xml, String mId) {
    
    String xsl = utils.utilsPrefix() + "fwiptables.xsl";
        //load the xsl and change the machine id
      String xslContent = utils.loadFile(xsl);
      xslContent = utils.replaceMID(xslContent,mId);

      String rsf= SimpleTransform.StartXsltContent(xml,xslContent);
      System.out.println("Written "+rsf.length()+ " bytes in the firewall configuration for host "+mId+"");
      return rsf;
      
      }

    /**
     * Returns a string with the ifconfig commands
     */
    public static String GetRouterIfConfig (String xml, String rId) {

      String xsl = utils.utilsPrefix() + "routerifconfig.xsl";
      //load the xsl and change the router id
      String xslContent = utils.loadFile(xsl);
      xslContent = Router.replaceRID(xslContent,rId);

      String rs= SimpleTransform.StartXsltContent(xml,xslContent);
      return rs;
    }


//----------------------------------------------------

  /**
   * Returns the current working directory
   */
  public static String pwd() {
    return System.getProperty("user.dir");
  }
  /**
   * Returns the absolute path of the file netml.xsd
   */
  public static String xsdPath() {
    String sep = System.getProperty("file.separator");
    String res = utils.pwd()  + sep + "xsd" + sep + "netml.xsd";
    return res;
    //return "/home/ivan79/cvsgiga/project/xmlschema/netml.xsd";
  }
  /**
   * Returns the absolute path of the directory containing the xsl files
   */
  public static String xslPath() {
    String sep = System.getProperty("file.separator");
    String res = utils.pwd()  + sep + "xslt" + sep ;
    return res;
    //return "/home/ivan79/cvsgiga/project/xslt/";
  }

//------------------------------------------------------

  /**
   * Parses the argument passed on the command line and returns a hashmap
   * that the main application can use to check and assign the values
   *
   * Here are the possible values for the keys:
   *  - x  (path to the xml file)
   *  - d  (name of the subdirectory that will contain the output files)
   *  - t  (type of router)
   */
  public static HashMap parseParams(String[] args) {

    HashMap map = new HashMap();

    for (int i = 0; i < args.length; i++) {

      // Debug only
      //System.out.println(i + " "+ args[i] + args.length);
      //
      String arg = args[i];

      //#######################
      //check for "-x ...../file.xml" (Router - Vlab)
      if (arg.equals("-x")) {
        if (++i == args.length) {  //look! it's ++i
          System.err.println("Missing xml filename");
          System.exit(201);
        }
        File ftmp = new File(args[i]);
        //Must exist and must be a file!
        if (! (ftmp.exists() && ftmp.isFile())) {
          System.err.println("Cannot open xml file");
          System.exit(202);
        }
        //If here the file exists!
        map.put("x",args[i]);
        continue;
      }

      //#######################
      //check for "-d outputdir"  (Router)
      if (arg.equals("-d")) {
        if (++i == args.length) {
          System.err.println("Missing output directory");
          System.exit(301);
        }
        //Must exist
        String outputDir = utils.pwd() + System.getProperty("file.separator") +
            "output" + System.getProperty("file.separator") + args[i];

        File ftmp = new File(outputDir);

        if (!ftmp.exists()) { //Must create it!
          System.out.println( outputDir +
                             " does not exist. I am going to create it...");

          //Create the directory under output directory
          if (ftmp.mkdir()) {
            System.out.println("...done");
          }
          else {
            System.err.println("Error: Can't create the directory");
            System.exit(302);
          }
        }
        else { //if here outputDir exists
          if (!ftmp.isDirectory()) {
            System.err.println("ERROR: \n" + outputDir +" is not a directory");
            System.exit(303);
          } //else OK
        }
        //We can now assume that the directory exists or had been created
        //So put its path in the map

        if ( ! outputDir.endsWith(System.getProperty("file.separator")))
          outputDir = outputDir.concat(System.getProperty("file.separator"));
        map.put("d",outputDir);
        continue;
      }

      //#######################
      //check for "-t type"     (Router)
      if (arg.equals("-t")) {
        if (++i == args.length) {
          System.err.println("Missing type argument");
          System.exit(401);
        }
        map.put("t",args[i]);
        continue;
      }

      //#######################
      //check for "-o ouptutFile"  (Vlab)
      if (arg.equalsIgnoreCase("-o")) {
        if (++i == args.length) {
          System.err.println("Missing output filename");
          System.exit(501);
        } else {
          File ftmp = new File(args[i]);
          if ( ftmp.exists() && ! ftmp.isFile()) {
            System.err.println("Sorry, "+args[i]+" is not a file");
            System.exit(502);
          }
        }
        // If here the file doesn't exist or exists and is a file!
        map.put("o", args[i]);
        continue;
      }


      //#######################
      //if here some parameter has not been recognized
      return null;

    }

    return map;

  }



}
