<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
               version="1.0"
							 xmlns:netml="http://www.xmlnetwork.org"
							 exclude-result-prefixes="netml">

	<xsl:output method="xml" indent="yes"/>

	<!-- As the definitions of the templates for Policy and for RipConf already exist we can include their files and use those definitions -->
	<!--xsl:include href="policy-juniper.xsl"/-->

	<!-- ###RouterID### --><xsl:variable name="routerID">r01</xsl:variable><!-- ###RouterID### -->
	<xsl:key name="kRouter" match="netml:NetML/netml:Routers/netml:RouterConf" use="@id"/>
	<xsl:key name="kPolicy" match="netml:NetML/netml:Routers/netml:RouterConf[@id=string($routerID)]/netml:Policy" use="@name"/>
	<xsl:key name="kConfederation" match="netml:NetML/netml:AS-List/netml:Confederations/netml:C" use="netml:ASMember/@id"/>
	<xsl:key name="kIface" match="netml:NetML/netml:Routers/netml:RouterConf[@id=string($routerID)]/netml:Interface/netml:ipAddress" use="../@name"/>


	<xsl:template match="/">
<configuration>
		<xsl:choose>
			<xsl:when test="count(key('kRouter',string($routerID))//netml:BGPConf/netml:view)>1">
<xsl:text>    </xsl:text><routing-instances>
	 			<xsl:for-each select="key('kRouter',string($routerID))/netml:BGPConf/netml:view">
<xsl:text>        </xsl:text><instance>
<xsl:text>            </xsl:text><name><xsl:value-of select="."/></name>
<xsl:text>            </xsl:text><instance-type>vrf</instance-type>
<xsl:text>            </xsl:text><routing-options>
					<xsl:variable name="localAS" select="key('kRouter',string($routerID))/netml:BGPConf/@as"/>
<xsl:text>                </xsl:text><autonomous-system>
<xsl:text>                    </xsl:text><as-number><xsl:value-of select="$localAS"/></as-number>
<xsl:text>					 </xsl:text></autonomous-system>
					<xsl:if test="count(key('kRouter',string($routerID))/netml:BGPConf/netml:RouterId)>0">
<xsl:text>                </xsl:text><router-id><xsl:value-of select="key('kRouter',string($routerID))/netml:BGPConf/netml:RouterId"/></router-id>
					</xsl:if>
					<xsl:if test="count(key('kConfederation',string($localAS)))>0">
						<xsl:for-each select="key('kConfederation',string($localAS))">
<xsl:text>                </xsl:text><confederation>
<xsl:text>                    </xsl:text><confederation-as><xsl:value-of select="@id"/></confederation-as>
							<xsl:for-each select="netml:ASMember">
<xsl:text>                    </xsl:text><members>
<xsl:text>                        </xsl:text><name><xsl:value-of select="@id"/></name>
<xsl:text>						  </xsl:text></members>
							</xsl:for-each>
<xsl:text>                </xsl:text></confederation>
						</xsl:for-each>
					</xsl:if>
					<xsl:if test="count(key('kRouter',string($routerID))/netml:BGPConf//netml:Default-Originate)>0 or count(key('kRouter',string($routerID))/netml:BGPConf/netml:StaticRoutes)>0">
<xsl:text>                </xsl:text><static>
						<xsl:if test="count(key('kRouter',string($routerID))/netml:BGPConf//netml:Default-Originate)>0">
<xsl:text>                    </xsl:text><route>
<xsl:text>                        </xsl:text><name>default</name>
<xsl:text>                        </xsl:text><next-hop>
<xsl:text>                            </xsl:text><name>self</name>
<xsl:text>                        </xsl:text></next-hop>
<xsl:text>                        </xsl:text><discard/>
 <xsl:text>                       </xsl:text><retain/>
 <xsl:text>                   </xsl:text></route>
						</xsl:if>
						<xsl:if test="count(key('kRouter',string($routerID))/netml:BGPConf/netml:StaticRoutes)>0">
							<xsl:for-each select="key('kRouter',string($routerID))/netml:BGPConf/netml:StaticRoutes/netml:s">
<xsl:text>                    </xsl:text><route>
<xsl:text>                        </xsl:text><name><xsl:value-of select="@address"/></name>
<xsl:text>                        </xsl:text><next-hop>
<xsl:text>                            </xsl:text><name>self</name>
<xsl:text>                        </xsl:text></next-hop>
<xsl:text>                        </xsl:text><discard/>
<xsl:text>                        </xsl:text><retain/>
<xsl:text>                    </xsl:text></route>
							</xsl:for-each>
						</xsl:if>
<xsl:text>                </xsl:text></static>
					</xsl:if>
					<xsl:if test="count(key('kRouter',string($routerID))/netml:BGPConf/netml:AggregateRoutes)>0">
<xsl:text>                </xsl:text><aggregate>
						<xsl:for-each select="key('kRouter',string($routerID))/netml:BGPConf/netml:AggregateRoutes/netml:route">
<xsl:text>                    </xsl:text><route>
<xsl:text>                        </xsl:text><name><xsl:value-of select="@address"/></name>
							<xsl:if test="count(netml:advertise)>0">
<xsl:text>                        </xsl:text><policy>
<xsl:text>                            </xsl:text><name><xsl:value-of select="netml:advertise"/></name>
<xsl:text>								</xsl:text></policy>
							</xsl:if>
							<xsl:if test="count(netml:attribute)>0">
<xsl:text>                        </xsl:text><policy>
<xsl:text>                            </xsl:text><name><xsl:value-of select="netml:attribute"/></name>
<xsl:text>								</xsl:text></policy>
							</xsl:if>
							<xsl:choose>
								<xsl:when test="@as-set='true'">
<xsl:text>                        </xsl:text><full/>
								</xsl:when>
								<xsl:otherwise>
<xsl:text>                        </xsl:text><brief/>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:choose>
								<xsl:when test="@type='active'">
<xsl:text>                        </xsl:text><active/>
								</xsl:when>
								<xsl:otherwise>
<xsl:text>                        </xsl:text><passive/>
								</xsl:otherwise>
							</xsl:choose>
<xsl:text>                    </xsl:text></route>
						</xsl:for-each>
<xsl:text>					.</xsl:text></aggregate>
					</xsl:if>
<xsl:text>            </xsl:text></routing-options>
<xsl:text>            </xsl:text><protocols>
<xsl:text>                </xsl:text><bgp>
					<xsl:apply-templates select="key('kRouter',string($routerID))/netml:BGPConf"/>
					 </bgp>
            </protocols>
        </instance>
		  		</xsl:for-each>
    </routing-instances>
			</xsl:when>
			<xsl:when test="count(key('kRouter',string($routerID))//netml:BGPConf/netml:view)=1">
    <routing-options>
				<xsl:variable name="localAS" select="key('kRouter',string($routerID))/netml:BGPConf/@as"/>
        <autonomous-system>
            <as-number><xsl:value-of select="$localAS"/></as-number>
		  </autonomous-system>
				<xsl:if test="count(key('kRouter',string($routerID))/netml:BGPConf/netml:RouterId)>0">
        <router-id><xsl:value-of select="key('kRouter',string($routerID))/netml:BGPConf/netml:RouterId"/></router-id>
				</xsl:if>
				<xsl:if test="count(key('kConfederation',string($localAS)))>0">
					<xsl:for-each select="key('kConfederation',string($localAS))">
        <confederation>
            <confederation-as><xsl:value-of select="@id"/></confederation-as>
						<xsl:for-each select="netml:ASMember">
            <members>
                <name><xsl:value-of select="@id"/></name>
				</members>
						</xsl:for-each>
		  </confederation>
					</xsl:for-each>
				</xsl:if>
				<xsl:if test="count(key('kRouter',string($routerID))/netml:BGPConf//netml:Default-Originate)>0 or count(key('kRouter',string($routerID))/netml:BGPConf/netml:StaticRoutes)>0">
        <static>
					<xsl:if test="count(key('kRouter',string($routerID))/netml:BGPConf//netml:Default-Originate)>0">
            <route>
                <name>default</name>
                <next-hop>
                    <name>self</name>
					 </next-hop>
                <discard/>
                <retain/>
				</route>
					</xsl:if>
					<xsl:if test="count(key('kRouter',string($routerID))/netml:BGPConf/netml:StaticRoutes)>0">
						<xsl:for-each select="key('kRouter',string($routerID))/netml:BGPConf/netml:StaticRoutes/netml:s">
            <route>
                <name><xsl:value-of select="@address"/></name>
                <next-hop>
                    <name>self</name>
					 </next-hop>
                <discard/>
                <retain/>
				</route>
						</xsl:for-each>
					</xsl:if>
		  </static>
				</xsl:if>
				<xsl:if test="count(key('kRouter',string($routerID))/netml:BGPConf/netml:AggregateRoutes)>0">
        <aggregate>
					<xsl:for-each select="key('kRouter',string($routerID))/netml:BGPConf/netml:AggregateRoutes/netml:route">
            <route>
                <name><xsl:value-of select="@address"/></name>
						<xsl:if test="count(netml:advertise)>0">
                <policy>
                		<name><xsl:value-of select="netml:advertise"/></name>
					 </policy>
						</xsl:if>
						<xsl:if test="count(netml:attribute)>0">
                <policy>
                     <name><xsl:value-of select="netml:attribute"/></name>
					 </policy>
						</xsl:if>
						<xsl:choose>
							<xsl:when test="@as-set='true'">
                <full/>
							</xsl:when>
							<xsl:otherwise>
                <brief/>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when test="@type='active'">
                <active/>
							</xsl:when>
							<xsl:otherwise>
                <passive/>
							</xsl:otherwise>
						</xsl:choose>
            </route>
					</xsl:for-each>
		  </aggregate>
				</xsl:if>
    </routing-options>
    <protocols>
        <bgp>
				<xsl:apply-templates select="key('kRouter',string($routerID))/netml:BGPConf"/>
		  </bgp>
    </protocols>
			</xsl:when>
		</xsl:choose>
</configuration>
	</xsl:template>

	<xsl:template match="netml:BGPConf">
		<xsl:if test="count(netml:Description)>0">
            <description><xsl:value-of select="netml:Description"/></description>
		</xsl:if>
		<xsl:if test="count(netml:Authentication)>0">
            <authentication-key><xsl:value-of select="netml:Authentication/@password"/></authentication-key>
		</xsl:if>
		<xsl:if test="count(netml:Local-Preference)>0">
            <local-preference><xsl:value-of select="netml:Local-Preference"/></local-preference>
		</xsl:if>
		<xsl:if test="count(netml:Timers/netml:holdtime)>0">
            <hold-time><xsl:value-of select="netml:Timers/netml:holdtime"/></hold-time>
		</xsl:if>
		<xsl:if test="count(netml:Dampening)>0">
            <damping/>
		</xsl:if>
		<xsl:if test="count(netml:LogUpDown)>0">
            <log-updown/>
		</xsl:if>
		<xsl:if test="count(netml:BestPathAlwaysCompareMed)>0">
            <path-selection>always-compare-med</path-selection>
		</xsl:if>
		<xsl:if test="count(netml:Policy)>0">
			<xsl:for-each select="netml:Policy">
				<xsl:if test="@type='import'">
            <import>
                <name><xsl:value-of select="."/></name>
				</import>
				</xsl:if>
			</xsl:for-each>
			<xsl:if test="count(netml:Dampening)>0">
            <import>
                <name><xsl:text>damp-BGP</xsl:text>
				<xsl:if test="count(netml:view)>0">
					<xsl:text>-</xsl:text><xsl:value-of select="netml:view"/>
				</xsl:if></name>
				</import>
			</xsl:if>
			<xsl:for-each select="netml:Policy">
				<xsl:if test="@type='export'">
            <export>
                <name><xsl:value-of select="."/></name>
				</export>
				</xsl:if>
			</xsl:for-each>
		</xsl:if>
		<xsl:apply-templates select="netml:PeerGroup"/>
	</xsl:template>
	
	<xsl:template match="netml:PeerGroup">
            <group>
                <name><xsl:value-of select="@name"/></name>
                <type>
		<xsl:variable name="peerAS" select="netml:Peer-AS/@name or ../netml:Peer-AS/@name"/>
		<xsl:variable name="localAS" select="../@as"/>
		<xsl:choose>
			<xsl:when test="$peerAS=$localAS">
				<xsl:text>internal</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>external</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
					 </type>
		<xsl:if test="count(netml:Description)>0">
                <description><xsl:value-of select="netml:Description"/></description>
		</xsl:if>
		<xsl:if test="count(netml:Peer-AS)>0">
                <peer-as><xsl:value-of select="netml:Peer-AS"/></peer-as>
		</xsl:if>
		<xsl:if test="count(netml:Local-AS)>0">
                <local-as>
                    <as-number><xsl:value-of select="netml:Local-AS/@name"/></as-number>
					 </local-as>
		</xsl:if>
		<xsl:if test="count(netml:Update-Source)>0">
			<xsl:variable name="ipAddr" select="key('kIface',@iface)"/>
                <local-address><xsl:value-of select="$ipAddr"/></local-address>
		</xsl:if>
		<xsl:if test="count(netml:Multihop)>0">
                <multihop>
                    <ttl><xsl:value-of select="netml:Multihop"/></ttl>
					 </multihop>
		</xsl:if>
		<xsl:if test="count(netml:Prefix-Limit)>0">
			<xsl:apply-templates select="netml:Prefix-Limit"/>
		</xsl:if>
		<xsl:if test="count(netml:Authentication)>0">
                <authentication-key><xsl:value-of select="netml:Authentication/@password"/></authentication-key>
		</xsl:if>
		<xsl:if test="count(netml:Remove-Private-AS)>0">
                <remove-private/>
		</xsl:if>
		<xsl:if test="count(netml:Timers/netml:holdtime)>0">
                <hold-time><xsl:value-of select="netml:Timers/netml:holdtime"/></hold-time>
		</xsl:if>
		<xsl:if test="count(netml:Policy)>0 or count(netml:List)>0 or count(netml:Next-Hop-Self)>0">
			<xsl:for-each select="netml:Policy">
				<xsl:if test="@type='import'">
                <import>
                    <name><xsl:value-of select="."/></name>
                </import>
				</xsl:if>
			</xsl:for-each>
			<xsl:for-each select="netml:List">
				<xsl:if test="@inOut='import'">
                <import>
                    <name><xsl:value-of select="."/></name>
                </import>
				</xsl:if>
			</xsl:for-each>
			<xsl:for-each select="netml:Policy">
				<xsl:if test="@type='export'">
                <export>
                    <name><xsl:value-of select="."/></name>
                </export>
				</xsl:if>
			</xsl:for-each>
			<xsl:for-each select="netml:List">
				<xsl:if test="@inOut='export'">
                <export>
                    <name><xsl:value-of select="."/></name>
                </export>
				</xsl:if>
			</xsl:for-each>
			<xsl:if test="count(netml:Next-Hop-Self)>0">
                <export>
                    <name><xsl:text>Next-Hop-Self</xsl:text></name>
                </export>
			</xsl:if>
		</xsl:if>
		<xsl:apply-templates select="netml:Neighbor"/>
				</group>
	</xsl:template>

	<xsl:template match="netml:Neighbor">
                <neighbor>
                    <name><xsl:value-of select="@address"/></name>
		<xsl:if test="count(netml:Description)>0">
                    <description><xsl:value-of select="netml:Description"/></description>
		</xsl:if>
		<xsl:if test="count(netml:Peer-AS)>0">
                    <peer-as><xsl:value-of select="netml:Peer-AS"/></peer-as>
		</xsl:if>
		<xsl:if test="count(netml:Local-AS)>0">
                    <local-as>
                        <as-number><xsl:value-of select="netml:Local-AS/@name"/></as-number>
						  </local-as>
		</xsl:if>
		<xsl:if test="count(netml:Update-Source)>0">
			<xsl:variable name="ipAddr" select="key('kIface',@iface)"/>
                    <local-address><xsl:value-of select="$ipAddr"/></local-address>
		</xsl:if>
		<xsl:if test="count(netml:Multihop)>0">
                    <multihop>
                        <ttl><xsl:value-of select="netml:Multihop"/></ttl>
						  </multihop>
		</xsl:if>
		<xsl:if test="count(netml:Prefix-Limit)>0">
			<xsl:apply-templates select="netml:Prefix-Limit"/>
		</xsl:if>
		<xsl:if test="count(netml:Authentication)>0">
                    <authentication-key><xsl:value-of select="netml:Authentication/@password"/></authentication-key>
		</xsl:if>
		<xsl:if test="count(netml:Timers/netml:holdtime)>0">
                    <hold-time><xsl:value-of select="netml:Timers/netml:holdtime"/></hold-time>
		</xsl:if>
		<xsl:if test="count(../../netml:Route-Reflector)>0">
			<xsl:apply-templates select="../../netml:Route-Reflector">
				<xsl:with-param name="neighAddr" select="@address"/>
			</xsl:apply-templates>
		</xsl:if>
		<xsl:if test="count(netml:Policy)>0 or count(netml:List)>0 or count(netml:Next-Hop-Self)>0">
			<xsl:for-each select="netml:Policy">
				<xsl:if test="@type='import'">
                    <import>
                        <name><xsl:value-of select="."/></name>
						  </import>
				</xsl:if>
			</xsl:for-each>
			<xsl:for-each select="netml:List">
				<xsl:if test="@inOut='import'">
                    <import>
                        <name><xsl:value-of select="."/></name>
						  </import>
				</xsl:if>
			</xsl:for-each>
			<xsl:for-each select="netml:Policy">
				<xsl:if test="@type='export'">
                    <export>
                        <name><xsl:value-of select="."/></name>
						  </export>
				</xsl:if>
			</xsl:for-each>
			<xsl:for-each select="netml:List">
				<xsl:if test="@inOut='export'">
                    <export>
                        <name><xsl:value-of select="."/></name>
						  </export>
				</xsl:if>
			</xsl:for-each>
			<xsl:if test="count(netml:Next-Hop-Self)>0">
                    <export>
                        <name><xsl:text>Next-Hop-Self</xsl:text></name>
						  </export>
			</xsl:if>
		</xsl:if>
                </neighbor>
	</xsl:template>

	<xsl:template name="Policy">
		<xsl:param name="parent"/>
		<xsl:param name="importList"/>
		<xsl:param name="exportList"/>
		<xsl:choose>
			<xsl:when test="$parent='bgp'">
			</xsl:when>
			<xsl:when test="$parent='group'">
				<xsl:text>            import [ </xsl:text><xsl:value-of select="$importList"/>
				<xsl:text> ];</xsl:text><xsl:text>&#13;&#10;</xsl:text>
				<xsl:text>            export [ </xsl:text><xsl:value-of select="$exportList"/>
				<xsl:text> ];</xsl:text><xsl:text>&#13;&#10;</xsl:text>
			</xsl:when>
			<xsl:otherwise>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="netml:Prefix-Limit">
		<xsl:variable name="parent" select="name(parent::*)"/>
		<xsl:choose>
			<xsl:when test="$parent='PeerGroup'">
                <family>
                    <inet>
                        <any>
                            <prefix-limit>
                                <maximum><xsl:value-of select="@maximum"/></maximum> <!-- mandatory -->
				<xsl:if test="count(netml:teardown)>0">
                                <teardown>
					<xsl:if test="count(netml:threshold)>0">
                                    <limit-threshold><xsl:value-of select="netml:threshold"/></limit-threshold>
					</xsl:if>
										  </teardown>
				</xsl:if>
                            </prefix-limit>
                        </any>
                    </inet>
                </family>
			</xsl:when>
			<xsl:otherwise>
                    <family>
                        <inet>
                            <any>
                                <prefix-limit>
                                    <maximum><xsl:value-of select="@maximum"/></maximum> <!-- mandatory -->
				<xsl:if test="count(netml:teardown)>0">
                                    <teardown>
					<xsl:if test="count(netml:threshold)>0">
                                        <limit-threshold><xsl:value-of select="netml:threshold"/></limit-threshold>
					</xsl:if>
												</teardown>
				</xsl:if>
										  </prefix-limit>
									 </any>
								</inet>
						  </family>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="netml:Route-Reflector">
		<xsl:param name="neighAddr"/>
		<xsl:for-each select="netml:Cluster">
			<xsl:for-each select="netml:Client">
				<xsl:if test="@address=$neighAddr">
                    <cluster><xsl:value-of select="../@id"/></cluster>
					<xsl:if test="../@fullyMeshed='true'">
                    <no-client-reflect/>
					</xsl:if>
				</xsl:if>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>

</xsl:stylesheet>
