<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  version="1.0" xmlns:netml="http://www.xmlnetwork.org">
	<!--xsl:comment>Translations for Cisco PIX Firewall v 0.1 author Daniele Cerra</xsl:comment-->
	<xsl:output method="text"/>
	<xsl:strip-space elements="*"/>
        <!-- ###MachineID### --><xsl:variable name="machineID">temp</xsl:variable><!-- ###MachineID### -->
	<xsl:variable name="synpres"/>
	<!--xsl:variable name="porta"/-->
        
	<xsl:template match="/">
        <xsl:choose>
			<xsl:when test="$machineID = 'temp'">
			<xsl:text>&#xD;&#xA;</xsl:text>
		<xsl:text>! Automatically generated firewall rules for Cisco PIX</xsl:text>
		<xsl:text>&#xD;&#xA;&#xD;&#xA;</xsl:text>
               <xsl:apply-templates select="//netml:FwallConf"/>
			</xsl:when>
                        
			<xsl:otherwise>
		<xsl:for-each select="//netml:FwallConf">
                <xsl:if test="netml:link =$machineID">
			<xsl:apply-templates select="."/>
                        </xsl:if>
                        
                        </xsl:for-each>
                        
                        </xsl:otherwise>
                        </xsl:choose>
			<xsl:text>end</xsl:text>
		
	</xsl:template>
	<!--xsl:template match="NetML">
	<xsl:apply-templates/>
	</xsl:template>

	<xsl:template match="Firewalls">
	<xsl:apply-templates/>
	</xsl:template-->
	<xsl:template match="netml:FwallConf">
		<!--xsl:template match="/"-->
		<xsl:text>! Firewall </xsl:text>
		<xsl:value-of select="netml:fw_id"/>
		<xsl:text>&#xD;&#xA;&#xD;&#xA;</xsl:text>
<xsl:if test="netml:acl/netml:effect">		
		<xsl:text>access-list </xsl:text>
		<xsl:value-of select="netml:acl/netml:name"/>
		<xsl:text> remark </xsl:text>
		<xsl:value-of select="netml:acl/netml:effect"/>
		<xsl:text>&#xD;&#xA;&#xD;&#xA;</xsl:text>
</xsl:if>		
<!--xsl:choose>
			<xsl:when test="options/sourcemulti">
				<xsl:param name="temp_port" select="options/sourcemulti/port"/>
				<xsl:for-each select="options/sourcemulti/port">
					<xsl:apply-templates select="//rule"/>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates select="//rule"/>
			</xsl:otherwise>
			</xsl:choose-->
		<xsl:for-each select="netml:acl/netml:construct">
			<xsl:text>! construct </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>: </xsl:text>
			<xsl:value-of select="@description"/>
			<xsl:text>&#xD;&#xA;</xsl:text>
			<xsl:for-each select="netml:rule">
				<xsl:choose>
					<xsl:when test="(count (descendant::netml:sourceport) &gt; 1) and (count (descendant::netml:destport) &lt; 2)">
						<xsl:for-each select="descendant::netml:sourceport">
							<xsl:apply-templates select="ancestor::netml:rule">
								<xsl:with-param name="sourcep">
									<xsl:value-of select="."/>
								</xsl:with-param>
								<xsl:with-param name="negatesp">
									<xsl:value-of select="@negate"/>
								</xsl:with-param>
							</xsl:apply-templates>
						</xsl:for-each>
					</xsl:when>
					<xsl:when test="(count (descendant::netml:destport) &gt; 1) and (count (descendant::netml:sourceport) &lt; 2)">
						<xsl:for-each select="descendant::netml:destport">
							<xsl:apply-templates select="ancestor::netml:rule">
								<xsl:with-param name="destp">
									<xsl:value-of select="."/>
								</xsl:with-param>
								<xsl:with-param name="negatedp">
									<xsl:value-of select="@negate"/>
								</xsl:with-param>
							</xsl:apply-templates>
						</xsl:for-each>
					</xsl:when>
					<xsl:when test="(count (descendant::netml:sourceport) &gt; 1) and (count (descendant::netml:destport) &gt; 1)">
						<xsl:for-each select="descendant::netml:sourceport">
							<xsl:variable name="tempsp" select="."/>
							<xsl:variable name="tempns" select="@negate"/>
							<xsl:for-each select="following-sibling::netml:destport">
								<xsl:apply-templates select="ancestor::netml:rule">
									<xsl:with-param name="sourcep">
										<xsl:value-of select="$tempsp"/>
									</xsl:with-param>
									<xsl:with-param name="negatesp">
										<xsl:value-of select="$tempns"/>
									</xsl:with-param>
									<xsl:with-param name="destp">
										<xsl:value-of select="."/>
									</xsl:with-param>
									<xsl:with-param name="negatedp">
										<xsl:value-of select="@negate"/>
									</xsl:with-param>
								</xsl:apply-templates>
							</xsl:for-each>
						</xsl:for-each>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="."/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
			<xsl:text>&#xD;&#xA;</xsl:text>
		</xsl:for-each>
		<!-- xsl:if test="//interface"-->
		<xsl:text>&#xD;&#xA;! Apply the ACL to the interface &#xD;&#xA;&#xD;&#xA;</xsl:text>
		<!--/xsl:if-->
		<xsl:for-each select="//netml:interface">
			<xsl:apply-templates select="."/>
		</xsl:for-each>
		<xsl:for-each select="//netml:rule">
			<xsl:if test="not( netml:interface )">
				<xsl:text>access-group </xsl:text>
				<xsl:value-of select="../../netml:name"/>
				<xsl:if test="@id">
					<xsl:text>_</xsl:text>
					<xsl:value-of select="@id"/>
				</xsl:if>
				<xsl:text> in interface all&#xD;&#xA;access-group </xsl:text>
				<xsl:value-of select="../../netml:name"/>
				<xsl:if test="@id">
					<xsl:text>_</xsl:text>
					<xsl:value-of select="@id"/>
				</xsl:if>
				<xsl:text> out interface all&#xD;&#xA;</xsl:text>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	<!-- Match rule -->
	<xsl:template match="netml:rule">
		<xsl:param name="sourcep"/>
		<xsl:param name="negatesp"/>
		<xsl:param name="destp"/>
		<xsl:param name="negatedp"/>
		<xsl:param name="synpresente"/>
		<xsl:param name="icmptype"/>
		<xsl:if test="netml:options/netml:TTL">
			<xsl:text>! Warning: Impossible to match TTL on PIX Firewalls for rule </xsl:text>
			<xsl:value-of select="@id"/>
			<xsl:text>&#xD;&#xA;</xsl:text>
		</xsl:if>
		<!--xsl:value-of select="$sourcep"></xsl:value-of-->
		<xsl:text>access-list </xsl:text>
		<xsl:value-of select="../../netml:name"/>
		<xsl:if test="@id">
			<xsl:text>_</xsl:text>
		</xsl:if>
		<xsl:value-of select="@id"/>
		<xsl:text> </xsl:text>
		<xsl:choose>
			<xsl:when test="netml:action = 'reject'">
				<xsl:text>deny</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="netml:action"/>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text> </xsl:text>
		<xsl:choose>
			<xsl:when test="netml:protocol = 'all'">
				<xsl:text>ip</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="netml:protocol"/>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text> </xsl:text>
		<!-- Se la source è un unico host, si aggiunge prima il termine HOST-->
		<xsl:choose>
			<xsl:when test="netml:source">
				<xsl:choose>
					<xsl:when test="netml:source/@mask">
						<xsl:value-of select="netml:source"/>
						<xsl:text> </xsl:text>
						<xsl:value-of select="netml:source/@mask"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="netml:source = 'any'">
								<xsl:value-of select="netml:source"/>
							</xsl:when>
							<xsl:when test="contains(netml:source,'/')">
								<xsl:value-of select="netml:source"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:text>host </xsl:text>
								<xsl:value-of select="netml:source"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>any</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text> </xsl:text>
		<!-- viene specificata una source port o un range di porte se è definita-->
		<xsl:if test="netml:options/netml:sourceport">
			<xsl:choose>
				<xsl:when test="count (netml:options/netml:sourceport) &gt; 1">
					<xsl:if test="$negatesp = 'true'">
						<xsl:text>n</xsl:text>
					</xsl:if>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="netml:options/netml:sourceport/@negate = 'true'">
						<xsl:text>n</xsl:text>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:text>eq </xsl:text>
			<xsl:choose>
				<!-- Override it, use $sourcep value instead -->
				<xsl:when test="$sourcep">
					<xsl:value-of select="$sourcep"/>
				</xsl:when>
				<!-- Either porta esplicita-->
				<xsl:otherwise>
					<xsl:value-of select="netml:options/netml:sourceport"/>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:text> </xsl:text>
		</xsl:if>
		<xsl:if test="netml:options/netml:sourceports">
			<xsl:text>range </xsl:text>
			<xsl:value-of select="netml:options/netml:sourceports/netml:from"/>
			<xsl:text> </xsl:text>
			<xsl:value-of select="netml:options/netml:sourceports/netml:to"/>
			<xsl:text> </xsl:text>
		</xsl:if>
		<!--xsl:if test="options/sourcemulti">
			<xsl:text>eq </xsl:text>
			<xsl:value-of select="port"/>
			<xsl:text> </xsl:text>
		</xsl:if-->
		<xsl:choose>
			<xsl:when test="netml:destmask">
				<xsl:value-of select="netml:destination"/>
				<xsl:text> </xsl:text>
				<xsl:value-of select="netml:destination/@mask"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="not(netml:destination)">
						<xsl:text>any</xsl:text>
					</xsl:when>
					<xsl:when test="netml:destination = 'any'">
						<xsl:value-of select="netml:destination"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>host </xsl:text>
						<xsl:value-of select="netml:destination"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text> </xsl:text>
		<xsl:if test="netml:options/netml:destport">
			<xsl:choose>
				<xsl:when test="count (netml:options/netml:destport) &gt; 1">
					<xsl:if test="$negatedp = 'true'">
						<xsl:text>n</xsl:text>
					</xsl:if>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="netml:options/netml:destport/@negate = 'true'">
						<xsl:text>n</xsl:text>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:text>eq </xsl:text>
			<xsl:choose>
				<!-- Override it, use $destp value instead -->
				<xsl:when test="$destp">
					<xsl:value-of select="$destp"/>
				</xsl:when>
				<!-- Either porta esplicita-->
				<xsl:otherwise>
					<xsl:value-of select="netml:options/netml:sourceport"/>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:text> </xsl:text>
		</xsl:if>
		<xsl:if test="netml:options/netml:destports">
			<xsl:text>range </xsl:text>
			<xsl:value-of select="netml:options/netml:destports/netml:from"/>
			<xsl:text> </xsl:text>
			<xsl:value-of select="netml:options/netml:destports/netml:to"/>
			<xsl:text> </xsl:text>
		</xsl:if>
		<xsl:for-each select="netml:options/netml:state">
			<xsl:if test=". = 'established'">
				<xsl:text>est </xsl:text>
			</xsl:if>
		</xsl:for-each>
		<xsl:if test="netml:log">
			<xsl:text>log </xsl:text>
			<xsl:if test="netml:log/@level">
				<xsl:value-of select="netml:log/@level"/>
				<xsl:text> </xsl:text>
			</xsl:if>
		</xsl:if>
		<xsl:if test="netml:protocol = 'icmp'">
			<xsl:for-each select="netml:options/netml:IcmpType">
				<xsl:value-of select="."/>
				<xsl:text> </xsl:text>
			</xsl:for-each>
			<!--xsl:value-of select="options/IcmpType"/>
			<xsl:text> </xsl:text-->
		</xsl:if>
		<xsl:if test="netml:protocol = 'tcp'">
			<xsl:variable name="synpres">
				<xsl:for-each select="netml:options/netml:TcpFlag">
					<xsl:if test=" (self::netml:TcpFlag = 'SYN')">true</xsl:if>
				</xsl:for-each>
			</xsl:variable>
			<xsl:for-each select="netml:options/netml:TcpFlag">
				<xsl:choose>
					<xsl:when test=".='SYN'">
						<xsl:text>syn</xsl:text>
					</xsl:when>
					<xsl:when test=".='FIN'">
						<xsl:text>fin</xsl:text>
					</xsl:when>
					<xsl:when test=".='RST'">
						<xsl:text>rst</xsl:text>
					</xsl:when>
					<xsl:when test=".='PUSH'">
						<xsl:text>push</xsl:text>
					</xsl:when>
					<xsl:when test=".='ACK'">
						<xsl:text>ack</xsl:text>
					</xsl:when>
					<xsl:when test=".='URG'">
						<xsl:text>urg</xsl:text>
					</xsl:when>
				</xsl:choose>
				<xsl:text> </xsl:text>
			</xsl:for-each>
			<xsl:if test="netml:options/netml:state = 'new' and not($synpres = 'true')">
				<xsl:text>syn </xsl:text>
			</xsl:if>
		</xsl:if>
		<xsl:if test="netml:options/netml:fragmented">
			<xsl:text>fragments </xsl:text>
		</xsl:if>
		<xsl:if test="netml:options/netml:TOS">
			<xsl:text>tos </xsl:text>
			<xsl:value-of select="netml:options/netml:TOS"/>
			<xsl:text> </xsl:text>
		</xsl:if>
		<!--xsl:if test="options/interval">
			<xsl:text>interval </xsl:text>
			<xsl:value-of select="options/interval"/>
			<xsl:text> </xsl:text>
		</xsl:if-->
		<xsl:text>&#xD;&#xA;</xsl:text>
	</xsl:template>
	<xsl:template match="netml:interface">
		<!--xsl:when test="interface/via"-->
		<xsl:for-each select="netml:via">
			<xsl:text>access-group </xsl:text>
			<xsl:value-of select="../../../../netml:name"/>
			<xsl:if test="../../@id">
				<xsl:text>_</xsl:text>
			</xsl:if>
			<xsl:value-of select="../../@id"/>
			<xsl:choose>
				<xsl:when test="../netml:direction">
					<xsl:text> </xsl:text>
					<xsl:value-of select="../netml:direction"/>
					<xsl:text> interface </xsl:text>
					<xsl:value-of select="."/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text> in interface </xsl:text>
					<xsl:value-of select="."/>
					<xsl:text>&#xD;&#xA;</xsl:text>
					<xsl:text>access-group </xsl:text>
					<xsl:value-of select="../../../../netml:name"/>
					<xsl:if test="../../@id">
						<xsl:text>_</xsl:text>
					</xsl:if>
					<xsl:value-of select="../../@id"/>
					<xsl:text> out interface </xsl:text>
					<xsl:value-of select="."/>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:text>&#xD;&#xA;</xsl:text>
		</xsl:for-each>
		<!--/xsl:when>
		<xsl:otherwise>
		<xsl:text>access-group </xsl:text>
		<xsl:value-of select="../name"/>

		</xsl:otherwise-->
		<!--/xsl:if-->
	</xsl:template>
</xsl:stylesheet>

<!-- Stylus Studio meta-information - (c) 2004-2005. Progress Software Corporation. All rights reserved.
<metaInformation>
<scenarios ><scenario default="no" name="testing area" userelativepaths="yes" externalpreview="no" url="base.xml" htmlbaseurl="" outputurl="ciscoprova.txt" processortype="internal" useresolver="no" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="fop" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal" customvalidator=""/><scenario default="yes" name="Firewall rules" userelativepaths="yes" externalpreview="no" url="Fwrules(diversi firewall).xml" htmlbaseurl="" outputurl="file:///f:/Demo/Automatically_generated_fwall_rules/Cisco_PIX.txt" processortype="internal" useresolver="no" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal" customvalidator=""/><scenario default="no" name="complete_static" userelativepaths="yes" externalpreview="no" url="static&#x2D;routing.xml" htmlbaseurl="" outputurl="pixtotal.txt" processortype="internal" useresolver="no" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal" customvalidator=""/><scenario default="no" name="Base" userelativepaths="yes" externalpreview="no" url="base.xml" htmlbaseurl="" outputurl="" processortype="internal" useresolver="no" profilemode="0" profiledepth="" profilelength="" urlprofilexml="" commandline="" additionalpath="" additionalclasspath="" postprocessortype="none" postprocesscommandline="" postprocessadditionalpath="" postprocessgeneratedext="" validateoutput="no" validator="internal" customvalidator=""/></scenarios><MapperMetaTag><MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no" ><SourceSchema srcSchemaPath="prova2.xml" srcSchemaRoot="construct" AssociatedInstance="file:///c:/Documents and Settings/Daniele/Desktop/Copia di NetML/doc/my xsd/prova2.xml" loaderFunction="document" loaderFunctionUsesURI="no"/></MapperInfo><MapperBlockPosition></MapperBlockPosition><TemplateContext></TemplateContext><MapperFilter side="source"></MapperFilter></MapperMetaTag>
</metaInformation>
-->