<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:netml="http://www.xmlnetwork.org">
	<!--xsl:comment>Translations for /sbin/iptables v 0.1 author Daniele Cerra</xsl:comment-->
	<xsl:output method="text"/>
	<xsl:strip-space elements="*"/>
	<!-- ###MachineID### --><xsl:variable name="machineID">temp</xsl:variable><!-- ###MachineID### -->
	<xsl:param name="found">no</xsl:param>


	<xsl:template match="/">
		<xsl:choose>
			<xsl:when test="$machineID = 'temp'">
				<xsl:text>#!/bin/bash&#xD;&#xA;#&#xD;&#xA;</xsl:text>
				<xsl:text># Automatically generated firewall rules for /sbin/iptables</xsl:text>
				<xsl:text>&#xD;&#xA;</xsl:text>
				<xsl:apply-templates select="//netml:FwallConf"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:for-each select="//netml:FwallConf">
					<xsl:if test="netml:link =$machineID">
						<xsl:apply-templates select="."/>
					</xsl:if>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="netml:FwallConf">
		<xsl:text># </xsl:text>
		<xsl:value-of select="netml:acl/netml:name"/>
		<xsl:text>: </xsl:text>
		<xsl:value-of select="netml:acl/netml:effect"/>
		<xsl:text>&#xD;&#xA;&#xD;&#xA;/sbin/iptables -F </xsl:text>
		<xsl:text>&#xD;&#xA;</xsl:text>
		<xsl:text>/sbin/iptables -P INPUT </xsl:text>
		<xsl:choose>
			<xsl:when test="descendant::netml:policy">
				<xsl:if test="descendant::netml:policy='permit'">
					<xsl:text>ACCEPT</xsl:text>
				</xsl:if>
				<xsl:if test="descendant::netml:policy='deny'">
					<xsl:text>DROP</xsl:text>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>ACCEPT</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text>&#xD;&#xA;</xsl:text>
		<xsl:text>/sbin/iptables -P OUTPUT </xsl:text>
		<xsl:choose>
			<xsl:when test="descendant::netml:policy">
				<xsl:if test="descendant::netml:policy='permit'">
					<xsl:text>ACCEPT</xsl:text>
				</xsl:if>
				<xsl:if test="descendant::netml:policy='deny'">
					<xsl:text>DROP</xsl:text>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>ACCEPT</xsl:text>
			</xsl:otherwise>
		</xsl:choose>

		<xsl:text>&#xD;&#xA;</xsl:text>




		<!-- SI ALTERA LA CHAIN FORWARD -->

		<xsl:text>/sbin/iptables -P FORWARD </xsl:text>
		<xsl:choose>
			<xsl:when test="descendant::netml:policy">
				<xsl:if test="descendant::netml:policy='permit'">
					<xsl:text>ACCEPT</xsl:text>
				</xsl:if>
				<xsl:if test="descendant::netml:policy='deny'">
					<xsl:text>DROP</xsl:text>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>ACCEPT</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:text>&#xD;&#xA;&#xD;&#xA;</xsl:text>

		<!-- CONSTRUCT DESCRIPTION -->

		<xsl:for-each select="netml:acl/netml:construct">
			<xsl:text># construct </xsl:text>
			<xsl:value-of select="@name"/>
			<xsl:text>: </xsl:text>
			<xsl:value-of select="@description"/>
			<xsl:text>&#xD;&#xA;</xsl:text>
			<xsl:for-each select="netml:rule">

				<!-- CALL RULE TEMPLATE FROM HERE --> 

				<xsl:choose>
					<xsl:when test="not(netml:log)">
						<xsl:choose>
							<xsl:when test="(netml:interface/netml:direction)">
							<xsl:apply-templates select="."/>
							<!--xsl:choose>
							  <xsl:when test="(count(netml:source) < 2) and (count(netml:destination)<2)">
								<xsl:apply-templates select="."/>
								</xsl:when>
								<xsl:when test="(count(netml:source) > 1) and (count(netml:destination)<2)">>
								 <xsl:for-each select="netml:source">
								 <xsl:apply-templates select="ancestor::netml:rule">
								 <xsl:with-param name="tempsource">.</xsl:with-param>
								 </xsl:apply-templates>
								 </xsl:for-each>
								 </xsl:when>
									<xsl:when test="(count(netml:source) < 2) and (count(netml:destination) > 1)">>
								 <xsl:for-each select="netml:destination">
								 <xsl:apply-templates select="ancestor::netml:rule">
								 <xsl:with-param name="tempsource">.</xsl:with-param>
								 </xsl:apply-templates>
								 </xsl:for-each>
								 </xsl:when>
								</xsl:choose-->
							</xsl:when>
							<xsl:when test="(netml:interface/netml:via) and (not(netml:interface/netml:direction))">
								<xsl:apply-templates select=".">
									<xsl:with-param name="inandout">in</xsl:with-param>
								</xsl:apply-templates>
								<xsl:apply-templates select=".">
									<xsl:with-param name="inandout">out</xsl:with-param>
								</xsl:apply-templates>
							</xsl:when>

							<xsl:otherwise>
								<xsl:apply-templates select=".">
									<xsl:with-param name="inandout">in</xsl:with-param>
								</xsl:apply-templates>
								<xsl:apply-templates select=".">
									<xsl:with-param name="forward">yes</xsl:with-param>
								</xsl:apply-templates>
								<xsl:apply-templates select=".">
									<xsl:with-param name="inandout">out</xsl:with-param>
								</xsl:apply-templates>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="(netml:interface/netml:direction)">

								<xsl:apply-templates select="."/>
								<xsl:apply-templates select=".">
									<xsl:with-param name="logp">true</xsl:with-param>
								</xsl:apply-templates>
							</xsl:when>

							<xsl:when test="(netml:interface/netml:via) and (not(netml:interface/netml:direction))">
								<xsl:apply-templates select=".">
									<xsl:with-param name="inandout">in</xsl:with-param>
								</xsl:apply-templates>
								<xsl:apply-templates select=".">
									<xsl:with-param name="inandout">out</xsl:with-param>
								</xsl:apply-templates>
								<xsl:apply-templates select=".">
									<xsl:with-param name="inandout">in</xsl:with-param>
									<xsl:with-param name="logp">true</xsl:with-param>
								</xsl:apply-templates>
								<xsl:apply-templates select=".">
									<xsl:with-param name="inandout">out</xsl:with-param>
									<xsl:with-param name="logp">true</xsl:with-param>
								</xsl:apply-templates>
							</xsl:when>

							<xsl:otherwise>
								<xsl:apply-templates select=".">
									<xsl:with-param name="inandout">in</xsl:with-param>
								</xsl:apply-templates>
								<xsl:apply-templates select=".">
									<xsl:with-param name="forward">yes</xsl:with-param>
								</xsl:apply-templates>
								<xsl:apply-templates select=".">
									<xsl:with-param name="inandout">out</xsl:with-param>
								</xsl:apply-templates>



								<xsl:apply-templates select=".">
									<xsl:with-param name="inandout">in</xsl:with-param>
									<xsl:with-param name="logp">true</xsl:with-param>
								</xsl:apply-templates>
								<xsl:apply-templates select=".">
									<xsl:with-param name="forward">yes</xsl:with-param>
									<xsl:with-param name="logp">true</xsl:with-param>
								</xsl:apply-templates>
								<xsl:apply-templates select=".">
									<xsl:with-param name="inandout">out</xsl:with-param>
									<xsl:with-param name="logp">true</xsl:with-param>
								</xsl:apply-templates>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
		</xsl:for-each>

		<xsl:if test="netml:nat">
			<xsl:text>&#xD;&#xA;# NAT &#xD;&#xA;</xsl:text>
			<xsl:if test="netml:nat/netml:translate">
				<xsl:text>/sbin/iptables -t nat -A POSTROUTING -o </xsl:text>
				<xsl:value-of select="netml:nat/netml:translate/@interface"/>
				<xsl:choose>
					<xsl:when test="netml:nat/netml:translate = ''">
						<xsl:text> -j MASQUERADE &#xD;&#xA;# (Dynamic NAT)</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text> -j SNAT --to </xsl:text>
						<xsl:value-of select="netml:nat/netml:translate"/>
						<xsl:text>&#xD;&#xA;# (Static NAT)</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text>&#xD;&#xA;</xsl:text>
			</xsl:if>
			<xsl:if test="netml:nat/netml:redirect">
				<xsl:text>/sbin/iptables -t nat -A PREROUTING -p tcp -i </xsl:text>
				<xsl:value-of select="netml:nat/netml:redirect/@interface"/>
				<xsl:text> --dport </xsl:text>
				<xsl:value-of select="netml:nat/netml:redirect/netml:hostport"/>
				<xsl:text> -j DNAT --to </xsl:text>
				<xsl:value-of select="netml:nat/netml:redirect/netml:target"/>
				<xsl:text>:</xsl:text>
				<xsl:value-of select="netml:nat/netml:redirect/netml:targetport"/>
			</xsl:if>
		</xsl:if>
	</xsl:template>
	<xsl:template match="netml:rule">
		<xsl:param name="logp"/>
		<xsl:param name="inandout"/>
		<xsl:param name="forward"/>
		<xsl:text>/sbin/iptables -A </xsl:text>
		<xsl:choose>
			<xsl:when test="$forward = 'yes'">
				<xsl:text>FORWARD</xsl:text>
			</xsl:when>
			<xsl:when test="$inandout = 'in' or netml:interface/netml:direction = 'in'">
				<xsl:text>INPUT</xsl:text>
			</xsl:when>
			<xsl:when test="$inandout = 'out' or netml:interface/netml:direction = 'out'">
				<xsl:text>OUTPUT</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<!--xsl:text> </xsl:text>
					<xsl:value-of select="interface/direction"/>
					<xsl:text> </xsl:text-->
			</xsl:otherwise>
		</xsl:choose>
		<!--xsl:value-of select="../../name"/-->
		<xsl:if test="netml:options/netml:fragmented">
			<xsl:text> -f</xsl:text>
		</xsl:if>
		<xsl:if test="netml:interface">
			<!--xsl:choose-->
			<xsl:if test="$inandout = 'in' or netml:interface/netml:direction = 'in'">
				<xsl:text> -i </xsl:text>
			</xsl:if>
			<xsl:if test="$inandout = 'out' or netml:interface/netml:direction = 'out'">
				<xsl:text> -o </xsl:text>
			</xsl:if>

			<xsl:choose>
				<xsl:when test="netml:interface/netml:via">
					<xsl:choose>
						<xsl:when test="netml:interface/netml:via = 'lo0'">
							<xsl:text>lo</xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="netml:interface/netml:via"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>+</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<xsl:if test="netml:source">
			<xsl:text> -s </xsl:text>
			<xsl:choose>
				<xsl:when test="netml:source = 'any'">
					<xsl:text>0/0</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="netml:source"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<xsl:if test="netml:source/@mask">
			<xsl:text>/</xsl:text>
			<xsl:value-of select="netml:source/@mask"/>
		</xsl:if>
		<xsl:if test="netml:destination">
			<xsl:text> -d </xsl:text>
			<xsl:choose>
				<xsl:when test="netml:destination = 'any'">
					<xsl:text>0/0</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="netml:destination"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<xsl:if test="netml:destination/@mask">
			<xsl:text>/</xsl:text>
			<xsl:value-of select="netml:destination/@mask"/>
		</xsl:if>
		<xsl:text> -p </xsl:text>
                <xsl:choose>
                <xsl:when test="netml:protocol">
		<xsl:value-of select="netml:protocol"/>
                </xsl:when>
                <xsl:otherwise><xsl:text>all</xsl:text></xsl:otherwise>
                </xsl:choose>
		<xsl:text> -j </xsl:text>
		<xsl:choose>
			<xsl:when test="$logp = 'true'">
				<xsl:text>LOG</xsl:text>
				<xsl:if test="netml:log/@level">
					<xsl:text> --log-level </xsl:text>
					<xsl:value-of select="netml:log/@level"/>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="netml:action='deny'">
					<xsl:text>DROP</xsl:text>
				</xsl:if>
				<xsl:if test="netml:action='permit'">
					<xsl:text>ACCEPT</xsl:text>
				</xsl:if>
				<xsl:if test="netml:action='reject'">
					<xsl:text>REJECT</xsl:text>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:if test="netml:options">


			<xsl:if test="netml:options/netml:IcmpType">
				<xsl:if test="netml:protocol = 'icmp'">
					<xsl:text> --icmp-type </xsl:text>
					<xsl:for-each select="netml:options/netml:IcmpType">
						<xsl:value-of select="."/>
						<xsl:if test="not(position()=last())">
							<xsl:text>,</xsl:text>
						</xsl:if>
					</xsl:for-each>
				</xsl:if>
			</xsl:if>
			<xsl:if test="netml:options/netml:TcpFlag">
				<xsl:if test="netml:protocol = 'tcp'">
					<xsl:text> --tcp-flags </xsl:text>
					<xsl:for-each select="netml:options/netml:TcpFlag">
						<xsl:apply-templates select="../netml:TcpFlag"/>
						<xsl:text> </xsl:text>
					</xsl:for-each>
				</xsl:if>
			</xsl:if>
			<xsl:if test="netml:options/netml:sourceport">
				<xsl:if test="count(netml:options/netml:sourceport)&gt;1">
					<xsl:text> -m multiport</xsl:text>
				</xsl:if>
				<xsl:text> --sport </xsl:text>
				<xsl:if test="netml:options/netml:sourceport/@negate = 'true'">
					<xsl:text>! </xsl:text>
				</xsl:if>
				<xsl:for-each select="netml:options/netml:sourceport">

					<xsl:value-of select="."/>
					<xsl:if test="position()!=last()">
						<xsl:text>,</xsl:text>
					</xsl:if>
				</xsl:for-each>
			</xsl:if>
			<xsl:if test="netml:options/netml:sourceports">
				<xsl:text> --sport </xsl:text>
				<xsl:value-of select="netml:options/netml:sourceports/netml:from"/>
				<xsl:text>:</xsl:text>
				<xsl:value-of select="netml:options/netml:sourceports/netml:to"/>
			</xsl:if>
			<xsl:if test="netml:options/netml:destport">
				<xsl:if test="count(netml:options/netml:destport)&gt;1">
					<xsl:text> -m multiport</xsl:text>
				</xsl:if>
				<xsl:text> --dport </xsl:text>
				<xsl:if test="netml:options/netml:sourceport/@negate = 'true'">
					<xsl:text>! </xsl:text>
				</xsl:if>
				<xsl:for-each select="netml:options/netml:destport">
					<xsl:value-of select="."/>
					<xsl:if test="position()!=last()">
						<xsl:text>,</xsl:text>
					</xsl:if>
				</xsl:for-each>
			</xsl:if>
			<xsl:if test="netml:options/netml:destports">
				<xsl:text> --dport </xsl:text>
				<xsl:value-of select="netml:options/netml:destports/netml:from"/>
				<xsl:text>:</xsl:text>
				<xsl:value-of select="netml:options/netml:destports/netml:to"/>
			</xsl:if>

			<xsl:if test="netml:options/netml:state">
				<xsl:text> -m state --state </xsl:text>
				<xsl:for-each select="netml:options/netml:state">
					<xsl:value-of select="."/>
					<xsl:if test=". = 'established'">
						<xsl:text>,related</xsl:text>
					</xsl:if>
					<xsl:if test="position() != last()">
						<xsl:text>,</xsl:text>
					</xsl:if>
				</xsl:for-each>
			</xsl:if>
			<xsl:if test="netml:options/netml:TOS">
				<xsl:text> -m tos --tos </xsl:text>
				<xsl:value-of select="netml:options/netml:TOS"/>
			</xsl:if>
			<xsl:if test="netml:options/netml:TTL">
				<xsl:text> -m ttl --ttl</xsl:text>
				<xsl:value-of select="netml:options/netml:TTL"/>
			</xsl:if>
		</xsl:if>
		<xsl:text>&#xD;&#xA;</xsl:text>
	</xsl:template>
	<xsl:template match="netml:TcpFlag">
		<xsl:choose>
			<xsl:when test="position()!=last()">
				<xsl:value-of select="."/>
				<xsl:text>,</xsl:text>
			</xsl:when>
			<xsl:otherwise>

				<xsl:value-of select="."/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>