<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0"
								xmlns:netml="http://www.xmlnetwork.org">

	<xsl:output method="text" />
	<xsl:strip-space elements="*"/>
		
	<!-- ###RouterID### --><xsl:variable name="routerID">r01</xsl:variable><!-- ###RouterID### -->
	<xsl:key name="kRouter" match="netml:NetML/netml:Routers/netml:RouterConf" use="@id"/>
	<xsl:key name="kPolicy" match="netml:NetML/netml:Routers/netml:RouterConf[@id=string($routerID)]/netml:Policy" use="@name"/>
	<xsl:key name="kIfaceAddr" match="netml:NetML/netml:Routers/netml:RouterConf[@id=string($routerID)]/netml:Interface/netml:ipAddress" use="../@name"/>

	<xsl:template match="/">
		<!--
		<xsl:variable name="ifaces"><!- lista delle interfacce che Rip utilizza per definire i neighbour ->
			<xsl:for-each select="key('kRouter',string($routerID))/netml:RipConf/netml:neighbour/netml:interface">
				<xsl:value-of select="."/><xsl:text> ; </xsl:text>
			</xsl:for-each>
		</xsl:variable><!- fine $ifaces ->
		<xsl:variable name="addrIfacesTmp"><!- lista delle interfacce che Rip richiama attraverso gli indirizzi ip ->
			<xsl:for-each select="key('kRouter',string($routerID))/netml:RipConf/netml:neighbour/netml:address">
				<xsl:variable name="addr" select="."/>
				<xsl:for-each select="/netml:addresses/netml:interface/netml:address">
					<xsl:if test=".=$addr">
						<xsl:value-of select="."/><xsl:text> / </xsl:text><xsl:value-of select="../@name"/><xsl:text> ; </xsl:text>
					</xsl:if>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:variable><!- fine $addrIfaces ->
		<!- it is important to check that an interface present in ifaces is not present in addrIfaces. This can be done rewriting addrIfaces ->
		<xsl:variable name="addrIfaces">
			<xsl:call-template name="comparisonIfacesAddrIfaces"><!- checks that interfaces in addrIfaces are not present in addrIfaces ->
				<xsl:with-param name="ifaces" select="$ifaces"/>
				<xsl:with-param name="addrIfaces" select="$addrIfacesTmp"/>
			</xsl:call-template>
		</xsl:variable> -->
		<xsl:text>!&#13;&#10;</xsl:text>
		<xsl:text>!Start of Interface Configuration</xsl:text>
		<xsl:text>&#13;&#10;</xsl:text>
		<xsl:text>!&#13;&#10;</xsl:text>
		<xsl:apply-templates select="key('kRouter',string($routerID))/netml:RouterConf/netml:Interface">
			<!--
			<xsl:with-param name="ifaces" select="$ifaces"/>
			<xsl:with-param name="addrIfaces" select="$addrIfaces"/> -->
		</xsl:apply-templates>
		<xsl:text>!End of Interface Configuration</xsl:text>
		<xsl:text>&#13;&#10;</xsl:text>
		<xsl:text>!&#13;&#10;</xsl:text>
	</xsl:template>

	<!-- xsl:template name="comparisonIfacesAddrIfaces">
		<xsl:param name="ifaces"/>
		<xsl:param name="addrIfaces"/>

		<xsl:variable name="beforeIfaces" select="substring-before($addrIfaces,' ; ')"/>
		<xsl:variable name="afterIfaces" select="substring-after($addrIfaces,' ; ')"/>

		<xsl:choose>
			<xsl:when test="$beforeIfaces!=''">
				<xsl:if test="not(contains($ifaces, $beforeIfaces)) and not(contains($afterIfaces,$beforeIfaces))">
					<xsl:value-of select="$beforeIfaces"/><xsl:text> ; </xsl:text>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="not(contains($ifaces, $addrIfaces)) and not(contains($afterIfaces,$addrIfaces))">
					<xsl:value-of select="$addrIfaces"/><xsl:text> ; </xsl:text>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>

		<xsl:if test="$afterIfaces!=''">
			<xsl:call-template name="comparisonIfacesAddrIfaces">
				<xsl:with-param name="ifaces" select="$ifaces"/>
				<xsl:with-param name="addrIfaces" select="$afterIfaces"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template> -->

	<xsl:template match="netml:Interface">
		<!--
		<xsl:param name="ifaces"/>
		<xsl:param name="addrIfaces"/> -->
		<xsl:text>interface </xsl:text><xsl:value-of select="@name"/>
		<xsl:text>&#13;&#10;</xsl:text>
		<xsl:if test="count(netml:description)>0">
			<xsl:text>  description </xsl:text><xsl:value-of select="netml:description"/>
			<xsl:text>&#13;&#10;</xsl:text>
		</xsl:if>
		<xsl:if test="count(netml:ipAddress)>0">
			<xsl:for-each select="netml:ipAddress">
				<xsl:text>  ip address </xsl:text><xsl:value-of select="."/>
				<xsl:text>&#13;&#10;</xsl:text>
			</xsl:for-each>
		</xsl:if>
		<xsl:if test="count(../netml:RipConf)>0">
			<xsl:apply-templates select="//netml:send_version|//netml:receive_version|//netml:split_horizon|//netml:authentication">
				<xsl:with-param name="iface" select="@name"/>
				<!--
				<xsl:with-param name="ifaces" select="$ifaces"/>
				<xsl:with-param name="addrIfaces" select="$addrIfaces"/> -->
			</xsl:apply-templates>
			<xsl:variable name="ifaceName" select="@name"/>
			<xsl:for-each select="../netml:RipConf/netml:policy">
				<xsl:if test="count(key('kPolicy',@name)/netml:General)>0">
					<xsl:call-template name="General">
						<xsl:with-param name="iface" select="$ifaceName"/>
						<xsl:with-param name="Pname" select="@name"/>
						<!--
						<xsl:with-param name="ifaces" select="$ifaces"/>
						<xsl:with-param name="addrIfaces" select="$addrIfaces"/> -->
					</xsl:call-template>
				</xsl:if>
			</xsl:for-each>
		</xsl:if>
		<xsl:text>!&#13;&#10;</xsl:text>
	</xsl:template>

	<xsl:template match="netml:send_version">
		<xsl:param name="iface"/>
		<!--
		<xsl:param name="ifaces"/>
		<xsl:param name="addrIfaces"/> -->
		<xsl:variable name="ancest" select="name(parent::*)"/>
		<xsl:variable name="send" select="."/>
		<xsl:choose>
			<xsl:when test="$ancest='RipConf'">
				<xsl:if test="$send!=../netml:receive_version">
					<xsl:variable name="ifaceList">
						<xsl:for-each select="../neighbour">
							<xsl:if test="count(netml:interface)>0">
								<xsl:value-of select="netml:interface"/>
							</xsl:if>
						</xsl:for-each>
					</xsl:variable>
					<xsl:variable name="addrList">
						<xsl:for-each select="../neighbour">
							<xsl:if test="count(netml:address)>0">
								<xsl:value-of select="netml:address"/>
							</xsl:if>
						</xsl:for-each>
					</xsl:variable>
					<xsl:choose>
						<xsl:when test="contains($ifaceList,$iface)">
							<xsl:text>  ip rip send version </xsl:text>
							<xsl:choose>
								<xsl:when test=".='1-2'">1-2 </xsl:when>
								<xsl:otherwise><xsl:value-of select="$send"/></xsl:otherwise>
							</xsl:choose>
							<xsl:text>&#13;&#10;</xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:for-each select="key('kIfaceAddr',string($iface))">
								<xsl:if test="contains($addrList,.)">
									<xsl:text>  ip rip send version </xsl:text>
									<xsl:choose>
										<xsl:when test=".='1-2'">1-2 </xsl:when>
										<xsl:otherwise><xsl:value-of select="$send"/></xsl:otherwise>
									</xsl:choose>
									<xsl:text>&#13;&#10;</xsl:text>
								</xsl:if>
							</xsl:for-each>
						</xsl:otherwise>
					</xsl:choose>
					<!-- xsl:if test="contains($ifaces,$iface)">
						<xsl:text>  ip rip send version </xsl:text>
						<xsl:choose>
							<xsl:when test=".='1-2'">1-2 </xsl:when>
							<xsl:otherwise><xsl:value-of select="$send"/></xsl:otherwise>
						</xsl:choose>
						<xsl:text>&#13;&#10;</xsl:text>
					</xsl:if>
					<xsl:if test="contains($addrIfaces,$iface)">
						<xsl:text>  ip rip send version </xsl:text>
						<xsl:choose>
							<xsl:when test=".='1-2'">1-2 </xsl:when>
							<xsl:otherwise><xsl:value-of select="$send"/></xsl:otherwise>
						</xsl:choose>
						<xsl:text>&#13;&#10;</xsl:text>
					</xsl:if> -->
				</xsl:if>
			</xsl:when>
			<xsl:when test="$ancest='neighbour'">
				<xsl:if test="count(../netml:interface)>0">
					<xsl:variable name="Ripsend" select="../../netml:send_version"/>
					<xsl:if test="$iface=../netml:interface and $send!=$Ripsend">
						<xsl:text>  ip rip send version </xsl:text>
						<xsl:choose>
							<xsl:when test=".='1-2'">1-2 </xsl:when>
							<xsl:otherwise><xsl:value-of select="."/></xsl:otherwise>
						</xsl:choose>
						<xsl:text>&#13;&#10;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:if test="count(../netml:address)>0">
					<xsl:variable name="addr" select="../netml:address"/>
					<xsl:variable name="Ripsend" select="../../netml:send_version"/>
					<xsl:for-each select="key('kIfaceAddr',string($iface))">
						<xsl:if test="$addr=.">
							<xsl:text>  ip rip send version </xsl:text>
							<xsl:choose>
								<xsl:when test=".='1-2'">1-2 </xsl:when>
								<xsl:otherwise><xsl:value-of select="$send"/></xsl:otherwise>
							</xsl:choose>
							<xsl:text>&#13;&#10;</xsl:text>
						</xsl:if>
					</xsl:for-each>
					<!--xsl:variable name="addrIface" select="concat($addr,' / ',$iface)"/>
					<xsl:if test="contains($addrIfaces,$addrIface) and $send!=$Ripsend">
							<xsl:text>  ip rip send version </xsl:text>
							<xsl:choose>
								<xsl:when test=".='1-2'">1-2 </xsl:when>
								<xsl:otherwise><xsl:value-of select="$send"/></xsl:otherwise>
							</xsl:choose>
							<xsl:text>&#13;&#10;</xsl:text>
						</xsl:if> -->
				</xsl:if>
			</xsl:when>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="netml:receive_version">
		<xsl:param name="iface"/>
		<!--
		<xsl:param name="ifaces"/>
		<xsl:param name="addrIfaces"/> -->
		<xsl:variable name="ancest" select="name(parent::*)"/>
		<xsl:variable name="receive" select="."/>
		<xsl:choose>
			<xsl:when test="$ancest='RipConf'">
				<xsl:if test="$receive!=../netml:send_version">
					<xsl:variable name="ifaceList">
						<xsl:for-each select="../neighbour">
							<xsl:if test="count(netml:interface)>0">
								<xsl:value-of select="netml:interface"/>
							</xsl:if>
						</xsl:for-each>
					</xsl:variable>
					<xsl:variable name="addrList">
						<xsl:for-each select="../neighbour">
							<xsl:if test="count(netml:address)>0">
								<xsl:value-of select="netml:address"/>
							</xsl:if>
						</xsl:for-each>
					</xsl:variable>
					<xsl:choose>
						<xsl:when test="contains($ifaceList,$iface)">
							<xsl:text>  ip rip receive version </xsl:text>
							<xsl:choose>
								<xsl:when test=".='1-2'">1-2 </xsl:when>
								<xsl:otherwise><xsl:value-of select="$receive"/></xsl:otherwise>
							</xsl:choose>
							<xsl:text>&#13;&#10;</xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:for-each select="key('kIfaceAddr',string($iface))">
								<xsl:if test="contains($addrList,.)">
									<xsl:text>  ip rip receive version </xsl:text>
									<xsl:choose>
										<xsl:when test=".='1-2'">1-2 </xsl:when>
										<xsl:otherwise><xsl:value-of select="$receive"/></xsl:otherwise>
									</xsl:choose>
									<xsl:text>&#13;&#10;</xsl:text>
								</xsl:if>
							</xsl:for-each>
						</xsl:otherwise>
					</xsl:choose>
						<!--xsl:if test="contains($ifaces,$iface)">
							<xsl:text>  ip rip receive version </xsl:text>
							<xsl:choose>
								<xsl:when test=".='1-2'">1-2 </xsl:when>
								<xsl:otherwise><xsl:value-of select="$receive"/></xsl:otherwise>
							</xsl:choose>
							<xsl:text>&#13;&#10;</xsl:text>
						</xsl:if>
						<xsl:if test="contains($addrIfaces,$iface)">
							<xsl:text>  ip rip receive version </xsl:text>
							<xsl:choose>
								<xsl:when test=".='1-2'">1-2 </xsl:when>
								<xsl:otherwise><xsl:value-of select="$receive"/></xsl:otherwise>
							</xsl:choose>
							<xsl:text>&#13;&#10;</xsl:text>
						</xsl:if> -->
				</xsl:if>
			</xsl:when>
			<xsl:when test="$ancest='neighbour'">
				<xsl:if test="count(../netml:interface)>0">
					<xsl:variable name="Ripreceive" select="../../netml:receive_version"/>
					<xsl:if test="$iface=../netml:interface and $receive=$Ripreceive">
						<xsl:text>  ip rip receive version </xsl:text>
						<xsl:choose>
							<xsl:when test=".='1-2'">1-2 </xsl:when>
							<xsl:otherwise><xsl:value-of select="."/></xsl:otherwise>
						</xsl:choose>
						<xsl:text>&#13;&#10;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:if test="count(../netml:address)>0">
					<xsl:variable name="addr" select="../netml:address"/>
					<xsl:variable name="Ripreceive" select="../../netml:receive_version"/>
					<!--xsl:variable name="addrIface" select="concat($addr,' / ',$iface)"/>
					<xsl:if test="contains($addrIfaces,$addrIface) and $receive!=$Ripreceive">
							<xsl:text>  ip rip receive version </xsl:text>
							<xsl:choose>
								<xsl:when test=".='1-2'">1-2 </xsl:when>
								<xsl:otherwise><xsl:value-of select="$receive"/></xsl:otherwise>
							</xsl:choose>
							<xsl:text>&#13;&#10;</xsl:text>
						</xsl:if> -->
					<xsl:for-each select="key('kIfaceAddr',string($iface))">
						<xsl:if test="$addr=.">
							<xsl:text>  ip rip receive version </xsl:text>
							<xsl:choose>
								<xsl:when test=".='1-2'">1-2 </xsl:when>
								<xsl:otherwise><xsl:value-of select="$receive"/></xsl:otherwise>
							</xsl:choose>
							<xsl:text>&#13;&#10;</xsl:text>
						</xsl:if>
					</xsl:for-each>
				</xsl:if>
			</xsl:when>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="netml:split_horizon">
		<xsl:param name="iface"/>
		<!--
		<xsl:param name="ifaces"/>
		<xsl:param name="addrIfaces"/> -->
		<xsl:variable name="sph" select="."/>
		<xsl:variable name="ifaceList">
			<xsl:for-each select="../neighbour">
				<xsl:if test="count(netml:interface)>0">
					<xsl:value-of select="netml:interface"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:variable name="addrList">
			<xsl:for-each select="../neighbour">
				<xsl:if test="count(netml:address)>0">
					<xsl:value-of select="netml:address"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="contains($ifaceList,$iface)">
				<xsl:choose>
					<xsl:when test="$sph='true' or $sph='1'">
						<xsl:text>  ip split-horizon</xsl:text>
						<xsl:text>&#13;&#10;</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>  no ip split-horizon</xsl:text>
						<xsl:text>&#13;&#10;</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:for-each select="key('kIfaceAddr',string($iface))">
					<xsl:if test="contains($addrList,.)">
						<xsl:choose>
							<xsl:when test="$sph='true' or $sph='1'">
								<xsl:text>  ip split-horizon</xsl:text>
								<xsl:text>&#13;&#10;</xsl:text>
							</xsl:when>
							<xsl:otherwise>
								<xsl:text>  no ip split-horizon</xsl:text>
								<xsl:text>&#13;&#10;</xsl:text>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
		<!--xsl:if test="contains($ifaces,$iface)">
			<xsl:choose>
				<xsl:when test="$sph='true' or $sph='1'">
					<xsl:text>  ip split-horizon</xsl:text>
					<xsl:text>&#13;&#10;</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>  no ip split-horizon</xsl:text>
					<xsl:text>&#13;&#10;</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<xsl:if test="contains($addrIfaces,$iface)">
			<xsl:choose>
				<xsl:when test="$sph='true' or $sph='1'">
					<xsl:text>  ip split-horizon</xsl:text>
					<xsl:text>&#13;&#10;</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>  no ip split-horizon</xsl:text>
					<xsl:text>&#13;&#10;</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:text>&#13;&#10;</xsl:text>
		</xsl:if> -->
	</xsl:template>

	<xsl:template match="netml:authentication">
		<xsl:param name="iface"/>
		<!--
		<xsl:param name="ifaces"/>
		<xsl:param name="addrIfaces"/> -->
		<xsl:variable name="type" select="netml:type"/>
		<xsl:variable name="key" select="netml:key | netml:key_chain/netml:name"/>
		<xsl:variable name="keyType">
			<xsl:choose>
				<xsl:when test="count(netml:key)>0">key</xsl:when>
				<xsl:when test="count(netml:key_chain)>0">key_chain</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="ifaceList">
			<xsl:for-each select="../neighbour">
				<xsl:if test="count(netml:interface)>0">
					<xsl:value-of select="netml:interface"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:variable name="addrList">
			<xsl:for-each select="../neighbour">
				<xsl:if test="count(netml:address)>0">
					<xsl:value-of select="netml:address"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
	<!-- using the supposition that I have a list of all the interfaces existing on the router, I can activate authentication -->
		<xsl:for-each select="netml:applyToInterface/netml:interface">
			<xsl:variable name="inface" select="."/>
			<xsl:choose>
				<xsl:when test="contains($ifaceList,$iface) and $iface=$inface">
			<!--xsl:if test="contains($ifaces,$iface) and $iface=$inface"-->
					<xsl:choose>
						<xsl:when test="$type='text'">
							<xsl:text>  ip rip authentication mode text</xsl:text>
							<xsl:text>&#13;&#10;</xsl:text>
							<xsl:text>  ip rip authentication key-chain </xsl:text>
							<xsl:choose>
								<xsl:when test="$keyType='key'"><xsl:text>RipK</xsl:text><xsl:text>&#13;&#10;</xsl:text></xsl:when>
								<xsl:otherwise><xsl:value-of select="$key"/><xsl:text>&#13;&#10;</xsl:text></xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>  ip rip authentication mode md5</xsl:text>
							<xsl:text>&#13;&#10;</xsl:text>
							<xsl:text>  ip rip authentication key-chain </xsl:text>
								<xsl:choose>
									<xsl:when test="$keyType='key'"><xsl:text>RipK</xsl:text><xsl:text>&#13;&#10;</xsl:text></xsl:when>
									<xsl:otherwise><xsl:value-of select="$key"/><xsl:text>&#13;&#10;</xsl:text></xsl:otherwise>
								</xsl:choose>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
			<!--/xsl:if>
			<xsl:if test="contains($addrIfaces,$iface)"-->
				<xsl:otherwise>
					<xsl:for-each select="key('kIfaceAddr',string($iface))">
						<xsl:if test="contains($addrList,.)">
							<xsl:choose>
								<xsl:when test="$type='text'">
									<xsl:text>  ip rip authentication mode text</xsl:text>
									<xsl:text>&#13;&#10;</xsl:text>
									<xsl:text>  ip rip authentication key-chain </xsl:text>
									<xsl:choose>
										<xsl:when test="$keyType='key'"><xsl:text>RipK</xsl:text><xsl:text>&#13;&#10;</xsl:text></xsl:when>
										<xsl:otherwise><xsl:value-of select="$key"/><xsl:text>&#13;&#10;</xsl:text></xsl:otherwise>
									</xsl:choose>
								</xsl:when>
								<xsl:otherwise>
									<xsl:text>  ip rip authentication mode md5</xsl:text>
									<xsl:text>&#13;&#10;</xsl:text>
									<xsl:text>  ip rip authentication key-chain </xsl:text>
									<xsl:choose>
										<xsl:when test="$keyType='key'"><xsl:text>RipK</xsl:text><xsl:text>&#13;&#10;</xsl:text></xsl:when>
										<xsl:otherwise><xsl:value-of select="$key"/><xsl:text>&#13;&#10;</xsl:text></xsl:otherwise>
									</xsl:choose>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:if>
					</xsl:for-each>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="General">
		<xsl:param name="iface"/>
		<xsl:param name="Pname"/>
		<!--xsl:param name="ifaces"/>
		<xsl:param name="addrIfaces"/>
		<xsl:if test="contains($ifaces,$iface)"> -->
		<xsl:variable name="ifaceList">
			<xsl:for-each select="../neighbour">
				<xsl:if test="count(netml:interface)>0">
					<xsl:value-of select="netml:interface"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:variable name="addrList">
			<xsl:for-each select="../neighbour">
				<xsl:if test="count(netml:address)>0">
					<xsl:value-of select="netml:address"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="contains($ifaceList,$iface)">
				<xsl:text>  ip policy route-map </xsl:text><xsl:value-of select="$Pname"/>
				<xsl:text>&#13;&#10;</xsl:text>
			</xsl:when>
		<!--xsl:if test="contains($addrIfaces,$iface)"> -->
			<xsl:otherwise>
				<xsl:for-each select="key('kIfaceAddr',string($iface))">
					<xsl:if test="contains($addrList,.)">
						<xsl:text>  ip policy route-map </xsl:text><xsl:value-of select="$Pname"/>
						<xsl:text>&#13;&#10;</xsl:text>
					</xsl:if>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
